# @(#)   desc/ak.com   7.2.0   07/16/98
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


*       inc=gsp00,vsp001,ggg00,gak00,vak001 trace=cccprint shrglob

regex(^vak[0123456789].*$)   trace_step_out

*-d     noshrglob


&if $MACH in [ SUN ]
vak06   -NO
vak22   -NO
&endif

&if $MACH = _IBMR2
vak681 -NO
&endif

&if $OSSPEC = OSF1
vak11   -OPT=-O0
vak681  -OPT=-O1
vak720  -OPT=-O0
vak542  -OPT=-O0
&endif

&if $OSSPEC = LINUX
# PTS 1109543
vak661  -OPT=-O1
vak663  -OPT=-O1
# PTS 1114153
vak58   -NO
&endif

&fast

&if $OSSPEC in [ SCO ]
vak16   -OPT=+O1
&endif

&if $OSSPEC in [ WIN32 ]
vak16   -NO -Od
# vak70, weil sonst in ak70or_qual die Zuweisung
# orqual_term := orqual_term + andqual_term - orqual_term - andqual_term
# im fasten Kern nicht ganz korrekte Ergebnisse liefert, siehe EXPL.vdnts
vak70	-NO -Od
&endif

&endfast

&if $MACH in [ HP9 ]
vak22   -OPT=+O1
vak23   -OPT=+O1
vak38   -OPT=+O1
vak70   -OPT=+O1
vak71   -OPT=+O1
vak720  -OPT=+O1
vak721  -OPT=+O1
vak723  -OPT=+O1
vak724  -OPT=+O1
vak77   -OPT=+O1
&endif

hak05.h inc=-vsp001
hak07.h inc=gsp00,ggg00,vak001,vsp008
hak10.h inc=gsp00,ggg00,vak001,gak40
hak12.h inc=-vsp001
hak34.h  inc=gsp00,vsp001,ggg00,vak001

hak341.h inc=ggg00,ggg92.h,vak001,hkb04.h,hak34.h,hgg08.h,heo55k.h,hbd21.h
hak263.h inc=gco00.h,vak001

vak01   inc=+vsp008
vak011  inc=+vsp008
vak04   inc=+ggg07,gak40,gak68
vak05   inc=+vsp006,vsp008
vak06   inc=+ggg11,vsp008
vak07   inc=+gsp03,gsp03_1,vsp008
vak09   inc=+vsp007,gbd00
vak10   inc=+gsp03,gsp03_1,ggg07,gak40,gak68
vak101  inc=+gsp03,gsp03_1 trace=none
vak102.cpp -except inc=hta01_3.h,hak10.h,vak001,hsp77.h,hgg01_1.h
vak12   inc=+vsp008
vak16   inc=+ggg07,gak68

&fast
vak11   -NO
&endfast
vak111  inc=+ggg07
vak13   inc=+vsp008
vak14   inc=+vsp008
vak15   inc=+ggg07,gak40
vak17   inc=+vsp007,vsp008 -NO
vak21   inc=+vsp008,ggg07,gak40
&fast
&if $OSSPEC in [ SVR4 ]
vak22   -NO
&endif
&endfast
vak24   inc=+ggg07,gak40
vak25   inc=+vsp008
vak26   inc=+vsp008
vak260  inc=+vsp008,gsp03,gsp03_1  INLINK=1
vak262  inc=+gsp03,gsp03_1,vsp008
vak263.cpp inc=vak001,hak263.h,hak12.h,hak34.h,hak07.h,hgg01.h,hgg17.h noshrglob dep=vco03.idl
vak28   inc=+vsp0031,ggg07,gak40,gak68
vak30   inc=+vsp008,vsp0031,gak30
vak31   inc=+vsp008,ggg07
vak34   inc=+gsp03,gsp03_1,vsp008  NOSIM=1
vak341.cpp  inc=vak001,hak05.h,hak07.h,hak34.h,hak341.h,hgg01.h,hkb04.h,hkb50.h,hbd04.h,gco00.h,hgg04.h,\
hgg10.h,hbd01.h,hbd02.h,gco02.h,heo01.h,heo02x.h,heo58.h,heo78.h,heo38.h noshrglob
vak35   inc=+gsp03,gsp03_1
vak36   inc=+gsp200,gsp03,gsp03_1,vsp006,vsp008
vak361  inc=+gsp03,gsp03_1,vsp0031
&if $OSSPEC in [ SVR4 ]
vak37   inc=+vsp008,vsp0031,ggg07,gak30,gak40 [f -NO f]
&else
vak37   inc=+vsp008,vsp0031,ggg07,gak30,gak40
&endif
vak38   inc=+vsp008,ggg07,gak40
gak40   inc=+ggg07
vak40   inc=+vsp002,gsp03,gsp03_1,vsp008,ggg07,gak40
vak41   inc=+gsp200,ggg07,gak40
&if $OSSPEC in [ SVR4 ]
vak42   inc=+vsp002,gsp200,gsp03,gsp03_1,ggg07,gkb00,gkb05,gak40 [f -NO f]
&else
vak42   inc=+vsp002,gsp200,gsp03,gsp03_1,ggg07,gkb00,gkb05,gak40
&endif
vak421  inc=+gsp92,ggg07,gak40
vak43   inc=+ggg07,gak40
vak44   inc=+ggg07,gak40
vak45   inc=+ggg07,gak40
vak46   inc=+vsp008,ggg07,gak40
vak47   inc=+ggg07,gak40
vak48   inc=+ggg07,gak40
vak49   inc=+ggg07,gak40
vak501  inc=+vsp008,ggg07,gak68
vak502  inc=+ggg07,gak68
vak503  inc=+ggg07,gak68
vak505  inc=+ggg07,gak68
vak506  inc=+vsp008
vak507  inc=+vsp008,ggg07,gak68,ggg11
vak508  inc=+vsp008
&if $OSSPEC in [ SVR4 ]
vak51   inc=+gsp03,gsp03_1,vsp006,vsp008 [f -NO f]
&else
vak51   inc=+gsp03,gsp03_1,vsp006,vsp008
&endif
vak52   inc=+vsp008
vak53   inc=+gsp03,gsp03_1,vsp008
vak54   inc=+vsp008,ggg07,gak70,gak68
vak541  inc=+vsp008
vak542  inc=+vsp008
vak543c noshrglob
vak544  inc=+gak30
vak545  inc=+vsp008
vak56   inc=+vsp008
vak562  inc=+ggg07,gak70
vak57   inc=+ggg07,gak70
vak58   inc=+ggg07,gak70
vak59   inc=+ggg07,gak70,gak68
vak60   inc=+vsp006,vsp008
vak61   inc=+vsp008
vak62   inc=+ggg07,gak70
&if $OS in [ WIN32 ] && $MACHINE in [ IA64 ]
# Itanium, PTS 1122247
vak63   -OPT=-Oitb1
&endif
vak641  inc=+vsp008
vak65   inc=+ggg07,gak68
vak660  inc=+vsp008,ggg07,gak70
vak661  inc=+ggg07,gak70
vak663  inc=+gsp03,gsp03_1
vak67   inc=+ggg07,gak70,gak68
&if $OSSPEC in [ WIN32 ]
# vak680, weil sonst a680standard das counted_multiplier nicht
# initialisiert und EXPL bei explain join Differenzen liefert
vak680	inc=+gsp03,gsp03_1,ggg07,gak68,gak70 [f -NO -Od f]
&else
vak680	inc=+gsp03,gsp03_1,ggg07,gak68,gak70
&endif
gak68   inc=+ggg07
vak681  inc=+ggg07,gak68
vak682  inc=+gsp03,gsp03_1,ggg07,gak68,gak70
vak683  inc=+vsp008,ggg07,gak68  trace=none
vak684  inc=+ggg07,gak68,gak70
vak685  inc=+ggg07,gak68
gak70   inc=+ggg07
vak70   inc=+ggg07,gak70
vak71   inc=+ggg07,gak70
vak720  inc=+ggg07,gak70
vak721  inc=+ggg07,gak70
vak722  inc=+ggg07,gak70,gak40
vak723  inc=+ggg07,gak70
vak724  inc=+ggg07,gak70
vak74   inc=+ggg07,gak68
vak77   inc=+vsp008
&if $OSSPEC in [ SVR4 ]
vak91   inc=+vsp002,gsp03,gsp03_1,vsp008 trace=none [s SLOW=y s] INLINK=1 [f -NO f]
&else
vak91	inc=+vsp002,gsp03,gsp03_1,vsp008 trace=none [s SLOW=y s] INLINK=1
&endif
vak92   inc=+gsp03,gsp03_1,vsp008
vak93   inc=+gsp03,gsp03_1,vsp008,ggg11
vak94   inc=+gsp03,gsp03_1,vsp008
vak95   inc=+gsp03,gsp03_1 no_trace_step_out
vak96   inc=+vsp0031,ggg11
vak97   inc=+ggg11
