/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
// cstm1dlg.cpp : implementation file
//

#include "LcWizard/StdAfx.h"
#include "LcWizard/LiveCache.h"
#include "LcWizard/cstm1dlg.h"
#include "LcWizard/LiveCacheAw.h"   /* PTS 1108379 LiveCacheaw -> LiveCacheAw */

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define d LiveCacheaw.m_Dictionary
#define ds(n,v) d[_T(#n)] = #v
#define dss(n,v) d[_T(#n)] = v
#define dr(n) d.RemoveKey(_T(#n))

/////////////////////////////////////////////////////////////////////////////
// CCustom1Dlg dialog


CCustom1Dlg::CCustom1Dlg()
	: CAppWizStepDlg(CCustom1Dlg::IDD)
{
	//{{AFX_DATA_INIT(CCustom1Dlg)
	m_DBProc = FALSE;
	m_UDF = FALSE;
	m_OMS = FALSE;
	m_SQL = FALSE;
	m_Version = _T("V1.0");
	//}}AFX_DATA_INIT
}


void CCustom1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CAppWizStepDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustom1Dlg)
	DDX_Check(pDX, IDB_DBPROC, m_DBProc);
	DDX_Check(pDX, IDB_UDF, m_UDF);
	DDX_Check(pDX, IDB_OMS, m_OMS);
	DDX_Check(pDX, IDB_SQL, m_SQL);
	DDX_Text(pDX, IDB_VERSION, m_Version);
	DDV_MaxChars(pDX, m_Version, 6);
	//}}AFX_DATA_MAP
}

// This is called whenever the user presses Next, Back, or Finish with this step
//  present.  Do all validation & data exchange from the dialog in this function.
BOOL CCustom1Dlg::OnDismiss()
{
  if (!UpdateData(TRUE))
		return FALSE;

  if ( 0 == m_Version.GetLength() )
		return FALSE;
  dss(VERSION, m_Version);
  
	// TODO: Set template variables based on the dialog's data.

	if (m_DBProc)
	{						// tree pane included
		ds(DBPROC, 1);
        if (m_SQL) ds(SQL, 1); else dr(SQL);
        if (m_OMS) ds(OMS, 1); else dr(OMS);
		dr(UDF);
	}

	if (m_UDF)
	{						// tree pane included
		ds(UDF, 1);
		dr(DBPROC);
		dr(SQL);
		dr(OMS);
	}

	return TRUE;	// return FALSE if the dialog shouldn't be dismissed
}


BEGIN_MESSAGE_MAP(CCustom1Dlg, CAppWizStepDlg)
	//{{AFX_MSG_MAP(CCustom1Dlg)
	ON_BN_CLICKED(IDB_DBPROC, OnDbproc)
	ON_BN_CLICKED(IDB_UDF, OnUdf)
	ON_BN_CLICKED(IDB_SQL, OnSql)
	ON_BN_CLICKED(IDB_OMS, OnOms)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCustom1Dlg message handlers

void CCustom1Dlg::OnDbproc() 
{
	CheckDlgButton(IDB_UDF, BST_UNCHECKED);
//	CheckDlgButton(IDB_DBPROC, BST_CHECKED);
}

void CCustom1Dlg::OnUdf() 
{
	CheckDlgButton(IDB_DBPROC, BST_UNCHECKED);
	CheckDlgButton(IDB_SQL, BST_UNCHECKED);
	CheckDlgButton(IDB_OMS, BST_UNCHECKED);
//	CheckDlgButton(IDB_UDF, BST_CHECKED);
}

BOOL CCustom1Dlg::OnInitDialog() 
{
	CAppWizStepDlg::OnInitDialog();
	
	// TODO: Add extra initialization here
	CheckDlgButton(IDB_UDF, BST_UNCHECKED);
	CheckDlgButton(IDB_DBPROC, BST_CHECKED);
	CheckDlgButton(IDB_SQL, BST_CHECKED);
	CheckDlgButton(IDB_OMS, BST_CHECKED);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCustom1Dlg::OnSql() 
{
	// TODO: Add your control notification handler code here
//	if (IsDlgButtonChecked(IDB_SQL) == BST_CHECKED)
//	    CheckDlgButton(IDB_SQL, BST_CHECKED);
}

void CCustom1Dlg::OnOms() 
{
	// TODO: Add your control notification handler code here
	
}
