/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
// LiveCache.cpp : Defines the initialization routines for the DLL.
//

#include "LcWizard/StdAfx.h"
#include <afxdllx.h>
#include "LcWizard/LiveCache.h"
#include "LcWizard/LiveCacheAw.h" /* PTS 1108379 LiveCacheaw -> LiveCacheAw */

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static AFX_EXTENSION_MODULE LiveCacheDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("LIVECACHE.AWX Initializing!\n");
		
		// Extension DLL one-time initialization
		AfxInitExtensionModule(LiveCacheDLL, hInstance);

		// Insert this DLL into the resource chain
		new CDynLinkLibrary(LiveCacheDLL);

		// Register this custom AppWizard with MFCAPWZ.DLL
		SetCustomAppWizClass(&LiveCacheaw);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("LIVECACHE.AWX Terminating!\n");

		// Terminate the library before destructors are called
		AfxTermExtensionModule(LiveCacheDLL);
	}
	return 1;   // ok
}
