/*!***************************************************************************

  module      : RTE_SystemPA.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: RTE System Interface
  description : Needed for Precision architecture specialties.
                aCC (C++ compiler on HPUX) does not support inline assembler

  last changed: 2000-05-29  12:22
  see also    : example.html ...
  first created:2000-05-25  19:15

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef RTE_SYSTEMPA_H
#define RTE_SYSTEMPA_H

/*!
  function: RTE_PATestAndSet
  description: Set a ZERO into given AlignedLockAddress and return former content

  Caller must use return value to make sure he succeeded in locking.

  arguments: AlignedLockAddress [in] Cacheline aligned (64Byte) lock address

  return value: 1 if not locked before, 0 else
 */
#if defined(__cplusplus)
extern "C" 
#endif
int RTE_PATestAndSet( volatile int *AlignedLockAddress );

#endif  /* RTE_SYSTEMPA_H */
