;****************************************************************************
;
; module      : RTE_SystemPA.s
;
; -------------------------------------------------------------------------
;
; responsible : Joerg Mensing - D027923
;
; special area: RTE System Interface
; description : Needed for Precision architecture specialties.
;               aCC (C++ compiler on HPUX) does not support inline assembler
;
; first created:2000-05-25  19:15
; last changed: 2000-05-25  19:46
;
; -------------------------------------------------------------------------
;
; copyright:    Copyright by SAP AG, 2000
;
;*****************************************************************************/
;
;**************************************************************************
; Test and set routines implemented with the LDCWS instruction
;
; The LDCWS instruction is very similar to a traditional test+set instruction
; with the following exceptions:
;   o Zero means set and One means clear.
;   o Word must be 16 byte aligned
;
; On future multiprocessor  machines,  normal load and store instructions could
; be reordered arbitrarily by the hardware.  The stws,ma 0() and ldws,ma 0()
; instructions will force a synchronization of reordered loads and stores.
;************************************************************************ 
;
; RTE_PATestAndSet(addr)
;*****************************************************
; addr must be 16Byte aligned!!!!
; RTE_PATestAndSet returns true if lock was already set
;****************************************************
;
;
;    ========== licence begin LGPL
;    Copyright (C) 2000 SAP AG
;
;    This library is free software; you can redistribute it and/or
;    modify it under the terms of the GNU Lesser General Public
;    License as published by the Free Software Foundation; either
;    version 2.1 of the License, or (at your option) any later version.
;
;    This library is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public
;    License along with this library; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;    ========== licence end
;

&if $MACH = PA20W
    .LEVEL 2.0W
    .SPACE $TEXT$,SORT=8
    .SUBSPA $CODE$,QUAD=0,ALIGN=8,ACCESS=0x2c,CODE_ONLY,SORT=24
RTE_PATestAndSet
    .PROC
    .CALLINFO 
    .ENTRY
; test+set, and return
     BV    0(rp)
     LDCW  (arg0), ret0
    .EXIT	
    .PROCEND

    .SPACE  $TEXT$
    .SUBSPA $CODE$
    .EXPORT RTE_PATestAndSet,ENTRY
    .END
&endif

&if $MACH in [ HP9, PA11 ]
    .code
    .proc
    .callinfo
    .export RTE_PATestAndSet
RTE_PATestAndSet

; test+set, and return
    bv     (rp)
    ldcws  (arg0), ret0
    .procend
&endif

