/****************************************************************************

  module      : RTESys_AtomicSwapSun.c

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Atomic Swapping 
  description : Support routine for SUN SPARC atomic swap

                Needed, since optimized version dumps core...

  last changed: 2000-05-26  17:41
  see also    : example.html ...
  first created:2000-05-26  17:33

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  STATIC/INLINE FUNCTIONS (PROTOTYPES)                                     *
 *===========================================================================*/



/*===========================================================================*
 *  METHODS                                                                  *
 *===========================================================================*/

#if defined(SUN)
  /*
   * function: SUN_AtomicSwap (SUN only)
   * description: Does an atomic swap of two integer values
   * 
   * After this call first value and second values are exchanged
   *
   * arguments: val1 [inout] First value
   *            val2 [inout] Second value
   */
/*SUN*/// extern "C" is needed or 'asm()' does not compile... 
/*SUN*/void RTESys_AtomicSwapSun(int *val1, int *val2)
/*SUN*/{
/*SUN*/    asm(" ld [%i1],%o0");
/*SUN*/    asm(" swap	[%i0],%o0");
/*SUN*/    asm(" st %o0,[%i1]");
/*SUN*/}
#endif /*SUN*/



/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/
