/****************************************************************************

  module      : Trace_Writer.hpp

  -------------------------------------------------------------------------

  responsible : TorstenS

  special area:
  description : Implementation of Kernel VTrace

  last changed: 2000-11-27  18:15
  see also    :

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef TRACE__WRITER_HPP
#define TRACE__WRITER_HPP



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"   // PASCAL: SP_basic_constants_and_types

#include "SAPDB/Trace/Trace_Manager.hpp"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

class Trace_Writer
{
public:

	static bool CreateInstance( tsp00_TaskId TaskId );

	static Trace_Writer& GetInstance(){return( *m_Instance );};

	tsp00_TaskId GetTaskId();

	void Run();

private:

	Trace_Writer( tsp00_TaskId &TaskId );

    bool Initialize();

	void Dump( tsp00_TaskId &TaskId );

private:

    static	Trace_Writer	*m_Instance;

	tsp00_TaskId			m_TaskId;
	Trace_Manager			&m_TraceManager;
    tsp00_PageAddr          m_pPage; // PTS 1120896 TS 2003-03-03
};

typedef Trace_Writer* Trace_WriterPtr;

#endif  /* TRACE__WRITER_HPP */
