/*!******************************************************************************

  @file         hbd01.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        filesysteminterface_1

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD01_H
#define HBD01_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\xb2\xa3\x81\xb7\x1b\x07\x1b\xd5\xb0\xe7\xb7\x71\x67\x72\xea\xc6'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal tsp00_Int4 b01bad_index_cnt;
externPascal pasbool b01downfilesystem;
externPascal tgg00_KeyRangeRecord b01keyrange;
externPascal tgg00_FileId b01niltree_id;
externPascal tsp00_Key b01zerokey;
externPascal tsp00_Key b01fullkey;

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01b_check_bytestr (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01bcreate_bytestr (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01cfwrite_configpage (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01change_filetype (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_FiletypeSet     &  new_filetype);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01check_table (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int2               long_col_cnt,
    tsp00_Int2               new_long_col_cnt,
    pasbool                  bWithExtendedCheck,
    pasbool                  check_long_existence);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01column_statistic (
    tgg00_MessBlock       &  m,
    tgg00_FileId          &  aux_file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool b01connect_allowed ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01create_filesystem (
    tgg00_TransContext    &  t,
    tsp00_Version         &  release_version,
    tsp00_PageAddr        &  dummy_p,
    tgg00_ConfigRestartParam  &  conf_param);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool b01db_full ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01dbspace_statistic (
    tgg00_TransContext    &  t,
    tgg00_DbSpaceInfo     &  info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01del_event_dw_compr ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01del_event_dw_displ ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01del_event_savepoint ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01destroy_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01empty_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01end_read_only (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01fcreate_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int2               stringcol_cnt,
    tsp00_Int2               varcol_cnt_off,
    pasbool                  no_tree_index);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01filestate (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01fn_new_and_unload (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  orig_id,
    tgg00_FileId          &  new_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01fset_write_state (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    pasbool                  on);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01get_bad_index_cnt (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01get_bad_indexid (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01get_data_cache_workload (
    tgg00_TransContext    &  t,
    tsp00_Int4            &  DataCacheSize,
    tsp00_Int4            &  OmsRollbackPageCnt,
    tsp00_Int4            &  OmsHistoryPageCnt,
    tsp00_Int4            &  OmsDataPageCnt,
    tsp00_Int4            &  SqlDataPageCnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01get_permlimit (
    tgg00_TransContext    &  t,
    tgg00_UserRef            user_ref,
    tsp00_Int4            &  perm_limit,
    tsp00_Int4            &  perm_count);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01lg_create_log_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01ldestroy_long_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01log_size (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01lread_logpage (
    tgg00_TransContext    &  t,
    tsp00_Int2               page_cnt,
    tsp00_PageNo             pno,
    tsp00_PageAddr        &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01lwrite_logpage (
    tgg00_TransContext    &  t,
    tsp00_Int2               page_cnt,
    tsp00_PageNo             log_pno,
    tsp00_PageAddr        &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01move_filecontent (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  source_id,
    tgg00_FileId          &  target_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01next_fdir_entry (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01no_of_data_devs ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01no_of_log_devs ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01pdestroy_perm_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01prefix_destroy_files (
    tgg00_TransContext    &  t,
    tgg00_Filename        &  prefix_fn,
    integer                  prefix_len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01psclear_save_pages_psm (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01pverify_participant (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    pasbool                  is_cold,
    pasbool                  bWithExtendedCheck);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01rec_align (
    tsp00_Int4               len);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01reload_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01rename_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  old_id,
    tgg00_FileId          &  new_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01reset_monitor (
    tgg00_MonitorPart_Param     part);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01restart_filesystem (
    tgg00_TransContext    &  t,
    pasbool                  NormalDBRestart);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01rread_restartpage (
    tgg00_TransContext    &  t,
    tsp00_PageAddr        &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01rwrite_restartpage (
    tgg00_TransContext    &  t,
    tsp00_PageAddr        &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01set_fileversion (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg91_FileVersion        new_fileversion,
    tsp00_Int2               new_long_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01show_treelocklist (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int4            &  rec_count);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01treeleafnodes (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_MessType_Param     m_type,
    tsp00_Int4            &  old_treeleafnodes);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01setto_zero_full_and_null ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01set_dw_io_bound (
    tsp00_TaskId             pid,
    integer                  percent);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01sfile_statistic (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    pasbool                  with_shortcol_file,
    pasbool                  with_sel,
    tgg00_SampleInfo      &  info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01show_monitor (
    tsp00_TaskId             TaskId,
    tgg00_ReferenceInfo   &  info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01shutdown_filesystem (
    tgg00_TransContext    &  t,
    pasbool                  log_active);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01shut_down_before_vshutdown (
    tgg00_TransContext    &  t,
    pasbool                  is_emergency);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01statistics_update (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int4            &  page_count,
    tsp00_Int4            &  rk_cnt_pp,
    pasbool                  only_sample);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01tcreate_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01tdestroy_loc_temp_files (
    tgg00_TransContext    &  t,
    tgg00_ServerdbNo      &  site);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01tinit_temp_cache (
    tgg00_TransContext    &  t,
    tsp00_Int4               buffers,
    pasbool                  is_control_session);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b01tmp_cache_size (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01tnext_temp_statistic (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tsp00_Int4            &  page_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01trelease_temp_cache (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01treset_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01unload_file (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01update_permlimit (
    tgg00_TransContext    &  t,
    tgg00_UserRef         &  user_ref,
    tsp00_Int4               perm_limit,
    tsp00_Int4               perm_count);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01verify_database (
    tgg00_TransContext    &  t,
    pasbool                  is_cold,
    pasbool                  bWithExtendedCheck,
    tsp00_Int4            &  perm_page_cnt,
    tsp00_Int4            &  bad_index_cnt,
    tsp00_Int4            &  total_bad_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01vstate_fileversion (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b01vfstate_fileversion (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd01AddInvToFileDirectory (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    pasbool                  SetNotAccessible);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd01CreateCoordinator (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  FileId,
    tgg00_MessType_Param     MessType);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd01StartCoordinator (
    tgg00_TransContext       t,
    tgg00_FileId          &  FileId,
    tgg00_MessType_Param     MessType);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal integer bd01UsableServerForParallelExecution (
    tsp00_TaskId             TaskId,
    tgg00_MessType_Param     MessType,
    pasbool                  InRegion);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

