
/*******************************************************************************

  module:       hbd09.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      filesysteminterface_9

  lastChanged:  2000-04-04

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

********************************************************************************/

#ifndef HBD09_H
#define HBD09_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: "\215\273\343\222\213\215 \332'\033b\220\203G]\177"
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"
#include "gkb00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void b09append_logentry (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_MessType2_Param     entry_part,
    tsp00_Int4               logbuf_size,
    void*                    logbuf_ptr,
    tsp00_Int4               logbuf_pos,
    tsp00_Int4               move_len,
    tsp00_Int4               entry_restlen,
    pasbool                  remember_last_logpos,
    tgg00_LogPos          &  last_file_logpos,
    tsp00_PageNo          &  rightmost_page);

externPascal void b09find_last_logpos (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    tgg00_LogPos          &  last_file_logpos,
    tsp00_PageNo          &  rightmost_page);

externPascal void b09locate_logentries_in_page (
    tgg00_TransContext    &  t,
    tgg00_LogPos             wanted_logpos,
    pasbool                  bForUpdate,
    tgg00_FileId          &  file_id,
    tbd_nodeptr           &  logpage,
    tbd_node              &  local_page,
    void*                    logbody,
    tsp00_Int4            &  logbody_len,
    tsp00_PageNo          &  next_pno);

externPascal void b09release_logpage (
    tgg00_TransContext    &  t,
    pasbool                  bWasUpdated,
    tgg00_FileId          &  file_id,
    tbd_nodeptr           &  logpage);

externPascal void b09trunc_logfile (
    tgg00_TransContext    &  t,
    tgg00_FileId          &  file_id,
    pasbool                  use_entry_seq,
    tkb00_LogEntrySeq     &  stop_entry_seq,
    tgg00_LogPos          &  last_file_logpos,
    tsp00_PageNo          &  rightmost_page);

externPascal void b09histfile_statistic (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    tsp00_PageNo             RightMostId,
    tgg91_TransNo         &  FirstTransId,
    pasbool               &  FirstTransIsUsed,
    tgg91_TransNo         &  LastTransId,
    pasbool               &  LastTransIsUsed,
    pasbool               &  bFileIsEmpty,
    pasbool                  bCountPages,
    tsp00_PageNo          &  TotalPageCount);

externPascal pasbool b09remove_history (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    tsp00_PageNo             RightMostId,
    pasbool                  DoExactUsageCheck);

externPascal void b09remove_oldest_history (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    tsp00_PageNo             RightMostId,
    pasbool               &  bAnythingDeleted);

externPascal void b09get_rightmost_id (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    tsp00_PageNo          &  RightMostId);

externPascal void b09save_rightmost_id (
    tgg00_TransContext    &  Trans,
    tgg00_FileId          &  FileId,
    tsp00_PageNo             RightMostId);


#endif

