
/*******************************************************************************

  module:       hbd10.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      conv_usm

  lastChanged:  2000-03-21

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

********************************************************************************/

#ifndef HBD10_H
#define HBD10_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\313\232P\016\217\331\222VnV\222\376?\337FI'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"
#include "vsp002.h"
#include "gbd01.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal pasbool b10backup_active ();

externPascal void b10bup_clear (
    tgg00_TransContext    &  t,
    pasbool                  clear_fbm);

externPascal void b10bup_handle_save (
    tgg00_TransContext    &  t,
    tsp00_Int4               last_backup_vers);

externPascal tsp00_Int4 b10bup_data_page_cnt (
    tsp00_TaskId             pid);

externPascal void b10bup_free_pno (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno,
    tbd1_conv_cb_ptr      &  cbptr);

externPascal tsp00_Int4 b10bup_max_used_data_pno (
    tsp00_TaskId             pid);

externPascal void b10bup_pno_ready (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno,
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offset);

externPascal void b10c_prepare_conv_flush (
    tgg00_TransContext    &  t);

externPascal void b10change_perm_percent_values (
    tsp_process_id           process_id,
    tsp_int4                 new_reserved_redo_size);

externPascal void b10check_space (
    tsp00_Int4               min_page_cnt,
    tbd_current_tree      &  current);

externPascal void b10clear_w_flags ();

externPascal void b10clear_converter (
    tgg00_TransContext    &  t,
    pasbool                  is_shutdown,
    pasbool                  is_k57restartrec_valid);

externPascal pasbool b10connect_allowed ();

externPascal void b10conv_scanner (
    tgg00_TransContext    &  t);

externPascal void b10converter_entry (
    tgg00_TransContext    &  t,
    pasbool                  for_reading,
    pasbool                  delete_entry,
    tsp00_PageNo             data_pno,
    pasbool                  is_perm_page,
    pasbool                  enter_region,
    tsp00_Int2            &  devsp_no,
    tsp00_Int4            &  offset);

externPascal void b10conv_restore_entry (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno,
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offs);

externPascal void b10create_converter (
    tgg00_TransContext    &  t,
    pasbool                  is_restore,
    tsp00_PageNo          &  usm_root_pno);

externPascal pasbool b10db_full ();

externPascal void b10decr_dc_synch_cnt (
    tsp00_TaskId             pid);

externPascal void b10dbspace_statistic (
    tgg00_TransContext    &  t,
    tgg00_DbSpaceInfo     &  info);

externPascal void b10devspace_statistic (
    tgg00_TransContext    &  t,
    tsp2_devname          &  device_name,
    tgg00_DbSpaceInfo     &  info);

externPascal void b10dnext_dev_pno (
    tgg00_TransContext    &  t,
    tsp00_Int2               devno,
    tsp00_PageNo          &  pno,
    pasbool               &  finished);

externPascal void b10dump_converter (
    tgg00_VfFileref       &  hostfile,
    tsp00_Page            &  b,
    tsp00_Int4            &  dump_pno,
    integer               &  pos,
    tsp00_VfReturn        &  hosterror,
    tsp00_ErrText         &  errtext);

externPascal void b10extension (
    tsp00_Int4               new_max_pno,
    tgg00_TransContext    &  t);

externPascal void b10finish_verification (
    tgg00_TransContext    &  t,
    tsp00_Int4            &  perm_page_cnt);

externPascal void b10flush_usm (
    tgg00_TransContext    &  t);

externPascal void b10get_data_pno_pos (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno,
    tsp00_Int4               restart_conv_vers,
    tbd_univ_ptr          &  p,
    tsp00_Int2            &  dev_no,
    tsp00_Int4            &  dev_offset);

externPascal void b10get_permlimit (
    tbd_current_tree      &  current,
    tsp00_Int4            &  perm_limit,
    tsp00_Int4            &  perm_count);

externPascal void bd10GetNumberOfAllAndUsedPages (
    tsp00_Int4            &  AllPageCnt,
    tsp00_Int4            &  UsedPageCnt);

externPascal tsp00_MoveObjPtr b10get_slot_w_flags ();

externPascal void b10init_verification (
    tgg00_TransContext    &  t);

externPascal void b10multiple_converter_entries (
    tgg00_TransContext    &  t,
    tbd_pagelistptr          plistaddr,
    tsp00_Int2               page_cnt,
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offset);

externPascal void b10rc_restart_converter (
    tgg00_TransContext    &  t,
    pasbool                  is_restore,
    tsp00_PageNo             usm_root_pno,
    tsp00_PageNo             max_used_data_pno);

externPascal void b10read_and_write_usm_page (
    tbd_current_tree      &  current,
    tsp00_PageNo             usm_pno);

externPascal pasbool b10reserve_used ();

externPascal void b10requ_pno (
    pasbool                  is_usm_req,
    tbd_current_tree      &  current,
    tsp00_PageNo          &  pno);

externPascal void b10rp_release_pno (
    tbd_current_tree      &  current,
    pasbool                  is_conv_touched,
    tsp00_PageNo             pno);

externPascal void b10set_last_backup_state (
    pasbool                  backup_crashed);

externPascal void b10u_prepare_usm_flush (
    tgg00_TransContext    &  t,
    tsp00_Int2               devno);

externPascal void b10update_permlimit (
    tbd_current_tree      &  current,
    tsp00_Int4               perm_limit,
    tsp00_Int4               perm_count);

externPascal void b10use_pno (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno);

externPascal void b10write_slot_to_page (
    tsp00_PageNo             conv_pno,
    tsp00_Int2               conv_slot,
    tbd1_conv_cb_ptr         cbptr,
    tbd00_ConverterSlot   &  slot_cont);


#endif

