/* @lastChanged: "1998-12-08  14:54"
 * @filename:    hbd11.h
 * @purpose:     "Free Block Management"
 * @release:     7.1.1.1
 * @see:         ""
 *
 * @copyright:   "Copyright by   SAP AG, 1998"


    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

 */


#ifndef HBD11_H
#define HBD11_H

/* ================================================================================ */
/* ==========                   IMPORT DECLARATION                       ========== */
/* ================================================================================ */

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*----------------------------------------------------------------------------*
 *  FUNCTION PROTOTYPES                                                       *
 *----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*
 *                        VBD11.C                                             *
 *----------------------------------------------------------------------------*/

externC void b11_init                   ( tsp00_Int2          max_data_devs, 
                                          tsp00_Int4          max_data_pages,
                                          tsp00_Int4          fbm_cache_pages ) ;

externC tsp00_Int4 b11_blocks_used        ( tsp00_Int2          devno );


/*----------------------------------------------------------------------------*
 *                        VBD110.C                                            *
 *----------------------------------------------------------------------------*/

externC void b11check_b_up              ( tsp00_Int2          devno, 
                                          tsp00_Int4         *num_b_up_bl, 
                                          tsp00_Int4         *num_b_up_pg );

/******************************************************************************/
#if defined (__cplusplus)
/******************************************************************************/

/*----------------------------------------------------------------------------*
 *                        VBD11.C                                             *
 *----------------------------------------------------------------------------*/
externC void b11_fbm_statistics         ( tsp00_Int4         &available,
                                          tsp00_Int4         &used     , 
                                          tsp00_Int4         &svp_free ) ;

/*----------------------------------------------------------------------------*
 *                        VBD11.C                                             *
 *----------------------------------------------------------------------------*/

externC void b11_init_fbm_for_dev       ( tgg00_TransContext    &t,
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            dev_size, 
                                          tgg00_BasisError      &tr_err  ) ;

externC void b11_mark_block             ( tgg00_TransContext    &t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm_Enum          marker, 
                                          tgg00_BasisError      &tr_err ) ;

externC void b11_get_free_block         ( tgg00_TransContext    &t, 
                                          tsp00_Int2            &devno,
                                          tsp00_Int4            &offset, 
                                          boolean               perm_page, 
                                          tgg00_BasisError &tr_err ) ;

externC void b11_mget_free_blocks       ( tgg00_TransContext    &t, 
                                          tsp00_Int2            min_block_cnt, 
                                          tsp00_Int2            &max_block_cnt,
                                          tsp00_Int2            &devno, 
                                          tsp00_Int4            &offset, 
                                          tgg00_BasisError      &tr_err) ;

externC void b11_free_marked_blocks     ( tgg00_TransContext    &t, 
                                          tbd_fbm_Enum          marker , 
                                          tgg00_BasisError      &tr_err);



externC void b11dump_fbm                ( tgg_vf_fileref        &hostfile, 
                                          tsp00_Page            &b, 
                                          tsp00_PageNo          &dump_pno, 
                                          tsp00_Int4            &pos, 
                                          tsp_vf_return         &hosterror, 
                                          tsp_errtext           &errtext);

/*----------------------------------------------------------------------------*
 *                        VBD110.C                                            *
 *----------------------------------------------------------------------------*/
externC void b11_mark_save_pages        ( tgg00_TransContext    &t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm_Enum          marker, 
                                          tgg00_BasisError      &tr_err ) ;

externC void b11_get_remove_pages_bitmap( tgg00_TransContext    &t, 
                                          tsp_moveobj_ptr       buf, 
                                          tsp00_Int4            bytes_wanted, 
                                          tsp00_Int4            &bytes_given,
                                          tsp00_PageNo          &bitmap_pno,
                                          tgg00_BasisError      &tr_err) ;

externC void b11_remove_pages           ( tgg00_TransContext    &t, 
                                          tsp00_Int4            BitmapPos, 
                                          tsp_moveobj_ptr       buf, 
                                          tsp00_Int4            bytes_given, 
                                          tgg00_BasisError      &tr_err) ;

externC void b11devsp_get_free_buffer   ( tgg00_TransContext    &t,
                                          tsp00_Int2            devno,
                                          tsp00_Int2            block_cnt,
                                          tsp_int1              mark_as_used,
                                          tsp00_Int4            *offset,
                                          tgg00_BasisError      &tr_err ) ;

externC void b11_check_fbm_balance      ( tgg00_TransContext    &t, 
                                          tsp00_Int4            devsp_compression,
                                          tsp00_Int4            devsp_balance, 
                                          boolean               &is_fragmented, 
                                          tgg00_BasisError      &tr_err);

externC void b11_get_last_frag_block    ( tgg00_TransContext    &t, 
                                          tsp00_Int2            &devno, 
                                          tsp00_Int4            &offset, 
                                          tsp00_Int4            &free_blocks, 
                                          tgg00_BasisError      &tr_err );
  
externC void b11_is_block_in_use        ( tgg00_TransContext    &t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          boolean               &is_in_use, 
                                          tgg00_BasisError      &tr_err );


externC void b11_clear_backup           ( tgg00_TransContext    &t, 
                                          tgg00_BasisError      &tr_err );

externC void b11_bup_pno_ready          ( tgg00_TransContext    &t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tgg00_BasisError      &tr_err );

externC void b11backup_block            ( tgg00_TransContext    &t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            max_num, 
                                          tsp00_Int4            &num, 
                                          tsp00_Int4            &nxt_offset, 
                                          tgg00_BasisError      &tr_err );

externC void b11_block_b_up_finish      ( tgg00_TransContext    &t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm_Enum          svp_mark, 
                                          tgg00_BasisError      &tr_err );

/******************************************************************************/
#else /* __cplusplus */
/******************************************************************************/

/*----------------------------------------------------------------------------*
 *                        VBD11.C                                             *
 *----------------------------------------------------------------------------*/
externC void b11_fbm_statistics         ( tsp00_Int4            *available,
                                          tsp00_Int4            *used     , 
                                          tsp00_Int4            *svp_free ) ;

externC void b11_init_fbm_for_dev       ( tgg00_TransContext    *t,
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            dev_size, 
                                          tgg00_BasisError      *tr_err  ) ;

externC void b11_mark_block             ( tgg00_TransContext    *t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm               marker, 
                                          tgg00_BasisError     *tr_err ) ;

externC void b11_get_free_block         ( tgg00_TransContext    *t, 
                                          tsp00_Int2            *devno,
                                          tsp00_Int4            *offset, 
                                          boolean               perm_page, 
                                          tgg00_BasisError      *tr_err ) ;

externC void b11_mget_free_blocks       ( tgg00_TransContext    *t, 
                                          tsp00_Int2            min_block_cnt, 
                                          tsp00_Int2            *max_block_cnt,
                                          tsp00_Int2            *devno, 
                                          tsp00_Int4            *offset, 
                                          tgg00_BasisError      *tr_err) ;

externC void b11_free_marked_blocks     ( tgg00_TransContext    *t, 
                                          tbd_fbm               marker , 
                                          tgg00_BasisError      *tr_err);



externC void b11dump_fbm                ( tgg_vf_fileref        *hostfile, 
                                          tsp00_Page            *b, 
                                          tsp00_PageNo          *dump_pno, 
                                          tsp00_Int4            *pos, 
                                          tsp_vf_return         *hosterror, 
                                          tsp_errtext           *errtext);

/*----------------------------------------------------------------------------*
 *                        VBD110.C                                            *
 *----------------------------------------------------------------------------*/
externC void b11_mark_save_pages        ( tgg00_TransContext    *t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm               marker, 
                                          tgg00_BasisError      *tr_err ) ;

externC void b11_get_remove_pages_bitmap( tgg00_TransContext    *t, 
                                          tsp_moveobj_ptr       buf, 
                                          tsp00_Int4            bytes_wanted, 
                                          tsp00_Int4            *bytes_given,
                                          tsp00_PageNo          *bitmap_pno,
                                          tgg00_BasisError      *tr_err) ;

externC void b11_remove_pages           ( tgg00_TransContext    *t, 
                                          tsp00_Int4            BitmapPos, 
                                          tsp_moveobj_ptr       buf, 
                                          tsp00_Int4            bytes_given, 
                                          tgg00_BasisError      *tr_err) ;

externC void b11devsp_get_free_buffer   ( tgg00_TransContext    *t,
                                          tsp00_Int2            devno,
                                          tsp00_Int2            block_cnt,
                                          tsp_int1              mark_as_used,
                                          tsp00_Int4            *offset,
                                          tgg00_BasisError      *tr_err ) ;

externC void b11_check_fbm_balance      ( tgg00_TransContext    *t, 
                                          tsp00_Int4            devsp_compression,
                                          tsp00_Int4            devsp_balance, 
                                          boolean               *is_fragmented, 
                                          tgg00_BasisError      *tr_err);

externC void b11_get_last_frag_block    ( tgg00_TransContext    *t, 
                                          tsp00_Int2            *devno, 
                                          tsp00_Int4            *offset, 
                                          tsp00_Int4            *free_blocks, 
                                          tgg00_BasisError      *tr_err );
  
externC void b11_is_block_in_use        ( tgg00_TransContext    *t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          boolean               *is_in_use, 
                                          tgg00_BasisError      *tr_err );


externC void b11_clear_backup           ( tgg00_TransContext    *t, 
                                          tgg00_BasisError      *tr_err );

externC void b11_bup_pno_ready          ( tgg00_TransContext    *t, 
                                          tsp00_PageNo          pno, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tgg00_BasisError      *tr_err );

externC void b11backup_block            ( tgg00_TransContext    *t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            max_num, 
                                          tsp00_Int4            *num, 
                                          tsp00_Int4            *nxt_offset, 
                                          tgg00_BasisError      *tr_err );

externC void b11_block_b_up_finish      ( tgg00_TransContext    *t, 
                                          tsp00_Int2            devno, 
                                          tsp00_Int4            offset, 
                                          tbd_fbm               svp_mark, 
                                          tgg00_BasisError      *tr_err );
/******************************************************************************/
#endif  /* __cplusplus */
/******************************************************************************/

#endif  /* HBD11_H */
