/*!******************************************************************************

  @file         hbd13.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        nodehandling

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD13_H
#define HBD13_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x55\x4d\x02\x1f\x63\x30\x54\x17\x7d\xe4\x4b\xe1\x73\xea\xec\x47'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void bd13CheckNode (
    tsp00_TaskId             taskId,
    tgg00_BasisError      &  trError,
    tbd_node_ptrs         &  pNodes,
    pasbool                  bExtendedCheck);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13b_get_node_by_blockaddr (
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offset,
    tsp00_Int4               dw_index,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13free_node (
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13free_pnos_after_unlock (
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd13GetNode (
    tbd_current_tree      &  Current,
    tsp00_PageNo             Pno,
    tbd00_PageLockMode_Param     PageLockMode,
    tbd_node_request_Param     NodeReq,
    tbd_node_ptrs         &  Nptrs);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13init_default_data_page (
    tsp00_Int2               Level,
    tsp00_PageNo             new_pno,
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13l_get_logpage (
    tgg00_LogPos             lpos,
    tbd_nodeptr           &  log_ptr,
    tbd_node              &  local_page,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13l_release_logpage (
    tbd_nodeptr           &  log_ptr,
    tgg00_TransContext    &  t,
    tbd_lru_info_Param       lru_info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13new_node (
    tsp00_Int2               lno,
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13new_object_node (
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13new_root (
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13pfree_pno (
    tsp00_PageNo             pno,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13r_release_node (
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current,
    tbd_lru_info_Param       lru_info);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13w_release_node (
    tbd_node_ptrs         &  nptr,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b13w2_rel_two_nodes (
    tbd_node_ptrs         &  nptr1,
    tbd_node_ptrs         &  nptr2,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

