/*!******************************************************************************

  @file         hbd15.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        secondary_storage_interface

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD15_H
#define HBD15_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\xbb\xd5\xa9\x2f\xc4\x45\xcc\xd9\x0b\x29\xbd\x50\xd4\x12\x5d\xdf'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"
#include "vsp002.h"
#include "gbd15.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal tbd_conf_glob b15;

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15allocate_confbuf ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15attach_dbdevices (
    tsp00_TaskId             pid,
    pasbool               &  force_config,
    tgg00_BasisError      &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15cfwrite_configpage (
    tgg00_TransContext    &  t,
    pasbool                  in_region);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15check_dual_log_integration (
    tgg00_TransContext    &  t,
    tsp00_PageNo             first_used_pno,
    tsp00_PageNo             last_used_pno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15cread_convpage (
    tsp00_PageNo             pno,
    pasbool                  read_even_area,
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15create_dbdevices (
    tgg00_TransContext    &  t,
    tsp00_Maxiobufaddr    &  dummy_p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15copy_mirr_log_cold (
    tgg00_TransContext    &  t,
    tbd_univ_ptr          &  io_obj,
    tsp00_Int4               dest_devno,
    tsp2_dev_type_Param      dest_devtype,
    integer                  buf_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15cwrite_convpage (
    tbd_univ_ptr          &  n,
    tsp00_Int4               converter_version,
    pasbool                  write_even_area,
    tsp00_Int2               page_cnt,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15diag_conv_page (
    tgg00_TransContext    &  t,
    tsp00_PageNo             conv_pno,
    pasbool                  is_read,
    tbd_univ_ptr          &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15diag_page (
    tgg00_TransContext    &  t,
    tsp00_PageNo             data_pno,
    pasbool                  is_read,
    tbd_univ_ptr          &  p);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15d_get_devname (
    tsp2_dev_type_Param      devtype,
    tsp00_Int4               devno,
    tsp2_devname          &  devname);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal integer b15data_dev_cnt ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15dbread_dbpage (
    tsp00_PageNo             pno,
    pasbool                  is_perm,
    tbd_univ_ptr          &  n,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15dbwrite_dbpage (
    tbd_univ_ptr          &  n,
    tsp00_Int4               converter_version,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15detach_dbdevices (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15detach_mirrored_device (
    tsp00_TaskId             pid,
    tsp2_dev_type_Param      dev_type,
    tsp00_Int4               dev_no);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15devread_devpage (
    tsp2_devname          &  devname,
    tsp00_PageNo             devpno,
    tbd_univ_ptr          &  n,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b15devsize (
    tsp2_dev_type_Param      dev_type,
    tsp00_Int4               devno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15devwrite_devpage (
    tsp2_devname          &  devname,
    tsp00_PageNo             devpno,
    tbd_univ_ptr          &  n,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15direct_read_dbpage (
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offset,
    tbd_univ_ptr          &  n,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15dump_bad_page (
    tsp00_TaskId             pid,
    char                     page_type_flag,
    const char*              file_ext,
    tsp00_Int4               bad_pno,
    void*                    buf_ptr,
    integer                  curr_buf_cnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15enable_devspace (
    tgg00_TransContext    &  t,
    tsp2_devname          &  devname);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15f_attach_dbdevice (
    tgg00_TransContext    &  t,
    pasbool               &  force_config);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15f_detach_dbdevice (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15file_opmsg (
    tsp00_Int4               msg_no,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15finish_reintegration (
    tgg00_TransContext    &  t,
    tsp00_Int4               devno,
    tsp2_dev_type_Param      dev_type);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15flush_sysbuf (
    tgg00_TransContext    &  t,
    tsp00_Int4               converter_version,
    tbd_nodeptr_list      &  nptr_list);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15get_data_page_info (
    tbd_univ_ptr             p,
    tsp00_PageNo          &  pno,
    pasbool               &  checkpoint_relevant);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15get_data_pno (
    tsp00_Int4            &  max_datapno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15get_devinfo (
    tgg00_TransContext    &  t,
    tsp2_devname          &  devname,
    tsp00_Int4            &  devno,
    tsp00_Int4            &  devsize);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15init_mapping (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15io_devspace_asyn (
    tgg00_TransContext    &  t,
    tgg00_VtraceType_Param     trace_object,
    tsp00_Int2               devsp_no,
    tsp00_Int4               fno,
    tbd_univ_ptr          &  p,
    tsp00_Int4               filepos,
    tsp00_Int4               blockcnt,
    tsp00_ErrText         &  errtext);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15l_attach_log_for_read (
    tgg00_TransContext    &  t,
    pasbool                  conf_logdev_only);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b15logsize (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15lread_log (
    tsp00_PageNo             pno,
    tsp00_Int2               buf_cnt,
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15lwrite_log (
    tsp00_PageNo             log_pno,
    tsp00_Int2               buf_cnt,
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15multiple_write_dbpage (
    tbd_univ_ptr          &  n,
    tsp00_Int2               dev_no,
    tsp00_Int4               dev_offset,
    tsp00_Int2               page_cnt,
    tsp00_Int4               converter_version,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15new_extension (
    tgg00_TransContext    &  t,
    tsp2_devname          &  new_dev,
    tsp2_devname          &  new_mirr_dev,
    tsp00_Int4               new_devsize,
    tsp2_dev_type_Param      dev_type,
    tsp00_Maxiobufaddr    &  dummy_p,
    pasbool                  is_cold);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15next_bad_dev (
    tsp00_TaskId             pid,
    tsp2_dev_type         &  dev_type,
    tsp00_Int4            &  devno,
    tsp2_devname          &  devname,
    pasbool               &  realy_bad);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15next_dev_info (
    tsp00_TaskId             pid,
    tsp00_Int4            &  dev_no,
    tsp2_dev_type         &  dev_type,
    tsp2_devname          &  dev_name,
    tsp00_Int4            &  dev_size,
    tbd15_IoState         &  dev_state,
    pasbool               &  dev_online);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b15no_of_data_devs ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal tsp00_Int4 b15no_of_log_devs ();

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15one_attach_dbdevice (
    tsp00_TaskId             pid,
    tsp2_devname          &  devname,
    tgg00_BasisError      &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15one_detach_dbdevice (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15reintegrate_dev (
    tgg00_TransContext    &  t,
    tsp2_devname          &  target_dev,
    tbd_univ_ptr          &  p,
    tsp00_Int4            &  devno,
    tsp2_dev_type         &  dev_type);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15restart_mapping (
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15rread_restart (
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15rupdate_restart (
    tgg00_TransContext    &  t,
    tsp00_PageNo             max_used_data_pno,
    tsp00_Int4               total_logdev_size,
    pasbool                  is_k57restartrec_valid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15rwrite_restart (
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15sys_log_dev_attach (
    tsp00_TaskId             pid,
    tsp00_Int4               devno,
    tsp2_dev_type_Param      dev_type,
    tsp2_devname          &  devname,
    tgg00_BasisError      &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15test_bad_page (
    tbd_univ_ptr          &  io_obj,
    tsp00_PageNo             pno,
    tgg00_PageType_Param     test_pt,
    tgg00_PageType2_Param     test_pt2,
    tgg00_BasisError      &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15test_mirrored_devices (
    tgg00_BasisError      &  e);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15uread_usmpage (
    tsp00_PageNo             pno,
    tbd_univ_ptr          &  p,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b15uwrite_usmpage (
    tbd_univ_ptr          &  p,
    pasbool                  enter_conv_region,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

