
/*******************************************************************************

  module:       hbd17.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      filedirectory

  lastChanged:  1999-07-30

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

********************************************************************************/

#ifndef HBD17_H
#define HBD17_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\364\251\303k`o\254\256\210\260\342\020<\263O\225'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal tbd_current_tree b17permfdir_current;
externPascal tbd_current_tree b17strcolfdir_current;
externPascal tbd_current_tree b17tempfdir_current;

externPascal void b17add_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    tgg00_TransContext    &  t);

externPascal void b17create_fdir (
    tgg00_TransContext    &  t,
    tsp00_PageNo          &  fdir_1_root,
    tsp00_PageNo          &  fdir_2_root);

externPascal void b17del_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17fadd_file_state (
    tbd_current_tree      &  current,
    tbd_file_state_set    &  new_state);

externPascal void b17fsub_file_state (
    tbd_current_tree      &  current,
    tbd_file_state_set    &  sub_state);

externPascal void b17get_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17next_del_fdir (
    tgg00_Filename        &  prefix,
    integer                  prefix_len,
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17repl_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17reset_read_only (
    tgg00_TransContext    &  t);

externPascal void b17restart_fdir (
    tgg00_TransContext    &  t,
    tsp00_PageNo             fdir_1_root,
    tsp00_PageNo             fdir_2_root);

externPascal void b17set_filestate (
    tgg00_Filename        &  fn,
    tgg00_TransContext    &  t,
    tbd_file_state_set    &  fstate,
    pasbool                  reset);

externPascal void b17state_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17succ_fdir (
    tgg00_Filename        &  fn,
    tgg00_Filename        &  next_fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t,
    pasbool                  include_strcols);

externPascal void b17tnext_temp_fdir (
    tgg00_Filename        &  fn,
    tgg00_Filename        &  next_fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);

externPascal void b17unload_fdir (
    tgg00_Filename        &  fn,
    tbd_fileinfo          &  fi,
    pasbool                  shared_file,
    tgg00_TransContext    &  t);


#endif

