
/*******************************************************************************

  module:       hbd20.h.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      BD-data-cache

  lastChanged:  2001-02-27

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999


    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
********************************************************************************/

#ifndef HBD20_H
#define HBD20_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\020\277\341C\223}\376\320u\177Y>\365PF!'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"
#include "gbd02.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal tsp00_Int4 b20buf;
externPascal pasbool b20check_svp_needed;
externPascal pasbool b20io_allocated;
externPascal tsp00_Int4 b20total_io_elems;

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd20CheckExclusiveLock (
    tbd_current_tree      &  Current,
    tbd_nodeptr              pRoot,
    tbd_nodeptr              pCBlock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd20CheckRootNptrs (
    tbd_current_tree      &  Current,
    tbd_nodeptr              pNode,
    tbd2_data_cb_ptr         pCBlock);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd20ClearAccessStatistic (
    tsp00_TaskId             TaskId);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd20GetAccessStatistic (
    tsp00_TaskId             TaskId,
    tsp00_8ByteCounter    &  LogTotal,
    tsp00_8ByteCounter    &  LogHit,
    tsp00_8ByteCounter    &  LogMiss,
    tsp00_8ByteCounter    &  OmsRollbackTotal,
    tsp00_8ByteCounter    &  OmsRollbackHit,
    tsp00_8ByteCounter    &  OmsRollbackMiss,
    tsp00_8ByteCounter    &  OmsHistoryTotal,
    tsp00_8ByteCounter    &  OmsHistoryHit,
    tsp00_8ByteCounter    &  OmsHistoryMiss,
    tsp00_8ByteCounter    &  OmsDataTotal,
    tsp00_8ByteCounter    &  OmsDataHit,
    tsp00_8ByteCounter    &  OmsDataMiss,
    tsp00_8ByteCounter    &  SqlDataTotal,
    tsp00_8ByteCounter    &  SqlDataHit,
    tsp00_8ByteCounter    &  SqlDataMiss);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd20GetWorkloadCounter (
    tsp00_Int4            &  DataCacheSize,
    tsp00_Int4            &  RollbackPageCnt,
    tsp00_Int4            &  OmsHistoryPageCnt,
    tsp00_Int4            &  OmsDataPageCnt,
    tsp00_Int4            &  SqlDataPageCnt);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20check_for_pno_in_freelist (
    tgg00_TransContext    &  t,
    tsp00_PageNo             pno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20dump_sysbuffer (
    tgg00_VfFileref       &  hostfile,
    tsp00_Page            &  b,
    tsp00_Int4            &  dump_pno,
    integer               &  pos,
    tsp00_VfReturn        &  host_error,
    tsp00_ErrText         &  errtext);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool b20exclusive_locks (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20f_lock_page_for_free (
    tbd_current_tree      &  current,
    tsp00_PageNo             pno,
    pasbool                  first_call,
    tbd02_CachePageState  &  PageState,
    pasbool               &  pno_released,
    tsp00_Int4            &  converter_version,
    tbd_nodeptr           &  nptr,
    tbd2_data_cb_ptr      &  cbptr);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20free_page (
    tgg00_TransContext    &  t,
    tsp00_PageNo             pno,
    tgg00_PageType_Param     page_type);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20flush_sysbuf (
    tgg00_TransContext    &  t,
    tsp00_PageNo             root,
    pasbool                  incl_temp);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20forced_io_done (
    tbd2_data_cb_ptr         cbptr,
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20fullest_data_cache (
    tsp00_TaskId             pid,
    pasbool               &  use_io_chain,
    integer               &  cache_no);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20gc_io_addr (
    integer                  gc_index,
    tbd_nodeptr           &  nptr);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20generate_pid_queue (
    tgg00_TransContext    &  t,
    tbd_pid_queue_ptr     &  head_ptr,
    tbd_pid_queue_ptr     &  free_ptr,
    tsp00_C24             &  alloc_msg_all,
    tsp00_C24             &  alloc_msg_elem,
    pasbool                  only_init,
    tsp00_Int4            &  sum_dynpool);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20get_page (
    tsp00_PageNo             pno,
    tbd_node_request_Param     node_req,
    tgg00_PageType_Param     page_type,
    tbd_nodeptr           &  nptr,
    tbd2_data_cb_ptr      &  cbptr,
    tbd02_CachePageState  &  PageState,
    tsp00_Int4            &  converter_version,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20get_pno_from_freelist (
    tgg00_TransContext    &  t,
    tsp00_PageNo          &  pno,
    tsp00_PageNo          &  usm_pno,
    tsp00_Int2            &  usm_index);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20i_dw_io_addr (
    tsp00_Int4               dw_index,
    tbd_univ_ptr          &  nptr);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20iget_page_for_io (
    tgg00_TransContext    &  t,
    integer                  reg_offset,
    pasbool                  use_io_chain,
    tsp00_Int2            &  flush_elems,
    tsp00_Int4               pid_index,
    tbd_univ_ptr          &  nptr,
    tbd2_data_cb_ptr      &  curr_cbptr,
    tbd2_data_cb_flush_list  &  cbptr_list,
    tsp00_Int4            &  converter_version,
    pasbool               &  completed);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20init_sysbuf (
    tgg00_TransContext    &  t,
    tsp00_Int4               buffers);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20io_elem_cnt (
    tsp00_TaskId             pid,
    integer                  reg_offset,
    tsp00_Int4            &  total_io_elems,
    tsp00_Int4            &  svp_io_elems,
    tsp00_Int4            &  copy_boundary);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20ireset_io_state (
    tsp00_TaskId             pid,
    integer                  reg_offset,
    tsp00_Int2               flush_elems,
    tbd_univ_ptr             nptr,
    tbd2_data_cb_flush_list  &  cbptr_list);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20iset_dw_index (
    tsp00_TaskId             pid,
    integer                  reg_offset,
    tsp00_Int4               dw_index);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool bd20IsPageRequested (
    tbd_nodeptr              cbptr);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20new_page (
    tsp00_PageNo             pno,
    tbd_nodeptr           &  nptr,
    tbd2_data_cb_ptr      &  cbptr,
    tbd02_CachePageState  &  PageState,
    tsp00_Int4            &  converter_version,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool b20pno_in_cache (
    tsp00_TaskId             pid,
    tsp00_PageNo             pno);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20pre_displace_io (
    tgg00_TransContext    &  t,
    integer                  reg_offset,
    tsp00_Int4               pid_index,
    pasbool               &  use_io_chain,
    tsp00_Int2            &  flush_elems,
    tbd_univ_ptr          &  nptr,
    tbd2_data_cb_flush_list  &  cbptr_list,
    tsp00_Int4            &  converter_version);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20prepare_savepoint (
    tgg00_TransContext    &  t,
    pasbool                  is_checkpoint);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20remove_pno_from_freelist (
    tsp00_PageNo             pno,
    tgg00_TransContext    &  t);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20r_release_page (
    tbd_current_tree      &  Current,
    tbd_nodeptr           &  nptr,
    tbd2_data_cb_ptr      &  cbptr,
    tbd_lru_info_Param       lru_info,
    tgg00_PageType_Param     page_type);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal pasbool bd20RequestExists (
    tbd_node_ptrs            RootNptrs);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20w_release_page (
    tbd_current_tree      &  current,
    tbd_nodeptr           &  nptr,
    tbd2_data_cb_ptr      &  cbptr,
    tgg00_Tfn             &  FileType,
    tbd02_SwapState       &  IoState,
    tsp00_Int4            &  converter_version);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20w2_rel_two_pages (
    tbd_current_tree      &  Current,
    tbd_nodeptr           &  nptr1,
    tbd2_data_cb_ptr      &  cbptr1,
    tbd_nodeptr           &  nptr2,
    tbd2_data_cb_ptr      &  cbptr2,
    tgg00_Tfn             &  FileType1,
    tgg00_Tfn             &  FileType2);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20repl_old_occup (
    tgg00_TransContext    &  t,
    tsp00_PageNo             pno,
    tgg00_PageType_Param     page_type,
    tbd2_data_cb_ptr         cbptr,
    pasbool                  set_ios_blocked);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20set_dw_io_bound (
    tsp00_TaskId             pid,
    integer                  percent);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20set_include_temp (
    tgg00_TransContext    &  t,
    pasbool                  set_include_temp);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20set_prevent_split (
    tsp00_TaskId             pid,
    pasbool                  prevent_split);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20shutdown_sysbuf (
    tsp00_TaskId             pid);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20svp_completed (
    tsp00_TaskId             pid,
    tsp00_C8              &  msg_label);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b20use_page (
    tbd_current_tree      &  current,
    tsp00_PageNo             pno,
    tgg00_PageType_Param     page_type,
    tbd2_data_cb_ptr         cbptr,
    tbd_node_request_Param     node_req,
    tbd_nodeptr           &  nptr);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

