
/*******************************************************************************

  module:       hbd21.h

  ------------------------------------------------------------------------------

  responsible:  JuergenP

  purpose:      BD-tdata-cache

  lastChanged:  1999-08-13

  generatedBy:  $TOOL/bin/ptocProto.py

  ------------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

********************************************************************************/

#ifndef HBD21_H
#define HBD21_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\347\326\267\267\346!^tW\036\032\211?\205(\314'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal pasbool b21is_control_session (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21init_temp_cache (
    tsp00_TaskId             pid,
    tsp00_Int4               buffers,
    pasbool                  allocate_monitor,
    pasbool                  is_control_session,
    tgg00_TempDataCachePtr  &  temp_cache_ptr,
    tgg00_BasisError      &  err);

externPascal void b21m_cmdid (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tgg00_Surrogate       &  cmdid);

externPascal void b21m_copy_result (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C3              &  copy_result);

externPascal void b21m_date_time (
    tsp00_Date            &  curr_date,
    tsp00_Time            &  curr_time);

externPascal void b21m_init_monitor_rec ();

externPascal pasbool b21m_is_select (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_fetch_calls (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_kb_calls (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_microsec (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_obj_hist_read_count (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21m_parse_again (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C3              &  parse_again);

externPascal void b21m_parseid (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C12             &  parseid);

externPascal tsp00_Int4 b21m_phys_ios (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21m_reset_monitor (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    pasbool                  reset_sum);

externPascal void b21m_roots (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4            &  cnt,
    tgg00_RootListPtr     &  rootlist_ptr);

externPascal tsp00_Int4 b21m_rows_fetched (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_rows_qual (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_rows_read (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_sec (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21m_strat (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C40             &  strategy);

externPascal tsp00_Int4 b21m_suspends (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21m_termid (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_TermId          &  termid);

externPascal void b21m_username (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_KnlIdentifier   &  username);

externPascal void b21m_values (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_MoveObjPtr      &  values_addr,
    tsp00_Int4            &  values_len);

externPascal tsp00_Int4 b21m_virt_reads (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21m_waits (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21mp_cmdid_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tgg00_Surrogate       &  cmdid);

externPascal void b21mp_copy_result_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C3              &  copy_result);

externPascal void b21mp_fetch_calls_put (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21mp_is_select (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    pasbool                  is_select);

externPascal void b21mp_kb_calls_put (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21mp_microsec_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               microsec);

externPascal void b21mp_new_sum_put (
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal void b21mp_obj_hist_read_count_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               read_count);

externPascal void b21mp_parse_again_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C3              &  parse_again);

externPascal void b21mp_parseid_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C12             &  parseid);

externPascal void b21mp_phys_ios_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               phys_ios);

externPascal void b21mp_root_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_PageNo             root);

externPascal void b21mp_rows_fetched_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               rows_fetched);

externPascal void b21mp_rows_qual_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               rows_qual);

externPascal void b21mp_rows_read_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               rows_read);

externPascal void b21mp_sec_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               sec);

externPascal void b21mp_strat_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_C40             &  strategy,
    tsp_int4                 len);

externPascal void b21mp_suspends_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               suspends);

externPascal void b21mp_termid_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_TermId          &  termid);

externPascal void b21mp_username_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_KnlIdentifier   &  username);

externPascal void b21mp_value_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_MoveObjPtr         curr_value_addr,
    tsp00_Int4               curr_value_len);

externPascal void b21mp_virt_reads_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               virt_reads);

externPascal void b21mp_waits_put (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    tsp00_Int4               waits);

externPascal void b21lcl_tfdir_root (
    tgg00_TempDataCachePtr     temp_cache_ptr,
    pasbool                  is_set,
    tsp00_PageNo          &  pno);

externPascal void b21temp_cache_release (
    tsp00_TaskId             pid,
    tgg00_TempDataCachePtr     temp_cache_ptr);

externPascal tsp00_Int4 b21tmp_cache_size (
    tgg00_TempDataCachePtr     temp_cache_ptr);


#endif

