/*!******************************************************************************

  @file         hbd72.h

  ------------------------------------------------------------------------------

  @author       JuergenP

  @brief        filestatistic

\if EMIT_LICENCE  

    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG
 
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end
\endif

********************************************************************************/

#ifndef HBD72_H
#define HBD72_H


/*===========================================================================*
 *     RefType: C++                                                          *
 *===========================================================================*/

/*===========================================================================*
 *     MD5: '\x10\x67\xd2\xbf\xa6\x5b\x05\x5f\x21\x28\x83\x2b\xa0\x7b\x63\x2b'
 *===========================================================================*/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "ggg00.h"
#include "gbd00.h"


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externPascal void b72cfile_card (
    tsp00_Int4            &  card,
    tsp00_Int4            &  rk_cnt_pp,
    pasbool                  card_only,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b72column_statistic (
    tgg00_MessBlock       &  m,
    tbd_current_tree      &  current,
    tbd_current_tree      &  temp_current,
    tgg00_Lkey            &  rk,
    tsp00_PageNo          &  next,
    tsp00_Int4            &  sec_key_cnt,
    tsp00_Int4            &  leafnodes);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void b72sfile_statistic (
    tsp00_Int2               stringcol_cnt,
    pasbool                  with_shortcol_file,
    pasbool                  scol_only,
    tgg00_SampleInfo      &  res_info,
    tbd_current_tree      &  current);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd72InitSampleInfo (
    tgg00_FileId          &  tree,
    tgg00_SampleInfo      &  info,
    tbd_stat_aux_vars     &  stat_aux_vars);

/* Don't edit this file by hand, it is generated by ptocProto.py */

externPascal void bd72SampleInfoEpilog (
    tgg00_SampleInfo      &  info,
    pasbool                  scol_only,
    tbd_stat_aux_vars     &  stat_aux_vars);

/* Don't edit this file by hand, it is generated by ptocProto.py */


#endif

