/****************************************************************************

  module      : vbd100.c

  -------------------------------------------------------------------------

  responsible : GertG

  special area: converter bit functions
  description : description ...


  last changed: 1998-09-03  9:23
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/
#include "gsp00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/

/*===========================================================================*
 *  LOCAL VARIABLES                                                          *
 *===========================================================================*/
 
/*===========================================================================*
 *  LOCAL FUNCTIONS (CODE)                                                   *
 *===========================================================================*/

/*===========================================================================*
 *  PUBLIC FUNCTIONS (CODE)                                                  *
 *===========================================================================*/


void b100_set_w_flag
(
    tsp00_PageNo datapno  /*in*/,
    tsp00_Uint1   w_flag   /*in*/
)
{
    extern      char* b10get_slot_w_flags();
    char        *flag_field;
    tsp00_Int2  flag_pos;
    
    flag_field = b10get_slot_w_flags() + (datapno / 8);
    flag_pos   = datapno % 8;

    *flag_field = (*flag_field & ~(0x01U << flag_pos)) | ( w_flag << flag_pos );
}

/*-----------------------------------------------------------*/

void b100_get_w_flag
(
    tsp00_PageNo datapno  /*in*/,
    tsp00_Uint1   *w_flag  /*out*/
)
{
    extern      char* b10get_slot_w_flags();
    char        *flag_field;
    tsp00_Int2  flag_pos;

    flag_field = b10get_slot_w_flags() + (datapno / 8);
    flag_pos   = datapno % 8;

    *w_flag = ((*flag_field & (0x01U << flag_pos)) >> flag_pos) & 0x01U;
}

/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/ 

