/****************************************************************************

  module      : vbd101.c

  -------------------------------------------------------------------------

  responsible : GertG

  special area: converter bit functions
  description : description ...


  last changed: 1998-09-03  9:23
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/
#include "gsp00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/

/*===========================================================================*
 *  LOCAL VARIABLES                                                          *
 *===========================================================================*/
 
/*===========================================================================*
 *  LOCAL FUNCTIONS (CODE)                                                   *
 *===========================================================================*/

/*===========================================================================*
 *  PUBLIC FUNCTIONS (CODE)                                                  *
 *===========================================================================*/


void b101_set_conv_flags
(
    tsp00_Int4    *flag_ptr /*in*/,
    tsp00_Int2    conv_slot /*in*/,
    tsp00_Uint1    p_flag    /*in*/, 
    tsp00_Uint1    m_flag    /*in*/,
    tsp00_Uint1    s_flag    /*in*/
)
{
    tsp00_Int4 *flag_field;
    tsp00_Int2 flag_pos;

    flag_field = flag_ptr + (conv_slot / 10);
    flag_pos   = (conv_slot % 10) * 3;
    
    *flag_field = (*flag_field & ~( 0x00000007UL << flag_pos)) | 
                ((4UL * p_flag + 2UL*m_flag + s_flag) << flag_pos);
}


/*-----------------------------------------------------------*/
void b101_get_conv_flags
(
    tsp00_Int4    *flag_ptr /*in*/,
    tsp00_Int2    conv_slot /*in*/,
    tsp00_Uint1    *p_flag   /*out*/, 
    tsp00_Uint1    *m_flag   /*out*/,
    tsp00_Uint1    *s_flag   /*out*/
)
{
    tsp00_Int4 flags;
    tsp00_Int4 *flag_field;
    tsp00_Int2 flag_pos;
    
    flag_field = flag_ptr + (conv_slot / 10);
    flag_pos   = (conv_slot % 10) * 3;

    flags = (((*flag_field & ( 0x00000007UL << flag_pos))) >> flag_pos ) & 
        0x00000007UL;
    *p_flag = ((tsp00_Uint1)(flags & 0x04) / 4);
    *m_flag = ((tsp00_Uint1)(flags & 0x02) / 2);
    *s_flag = (tsp00_Uint1)(flags & 0x01);
}

/*-----------------------------------------------------------*/
void b101_set_devaddr
(
    tsp00_Uint4     *conv_devslot,  /* out */
    tsp00_Int2      *devno,         /* in  */
    tsp00_Int4      *devoffset      /* in  */
)
{
    *conv_devslot  = (( (tsp00_Uint4)*devno & 0xFFU) << 24) | *devoffset;
}

/*-----------------------------------------------------------*/
void b101_get_devaddr
(
    tsp00_Uint4     *conv_devslot,  /* in  */
    tsp00_Int2      *devno,         /* out */
    tsp00_Int4      *devoffset      /* out */
)
{
    *devoffset = *conv_devslot & 0xFFFFFFU;
    *devno     = *conv_devslot >> 24;
}


/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/ 
