/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
#if defined(CN72) && defined(_WIN32)
  #line 3 "d:\\v72\\sys\\src\\cn\\hcn50.h"
#endif 

/*! 
  -----------------------------------------------------------------------------
 
  module: hcn50.h
 
  -----------------------------------------------------------------------------
 
  responsible:  BerndV
 
  special area: DBMServer User Management
   
  description:  DBMServer User Management - Specification

  version:      7.2.* 

  -----------------------------------------------------------------------------
 
                          Copyright by SAP AG, 1998
 
  -----------------------------------------------------------------------------
*/

#ifndef _HCN50_H_
#define _HCN50_H_

/*
  -----------------------------------------------------------------------------
  includes
  -----------------------------------------------------------------------------
 */
#include "gcn00.h"

/*
  -----------------------------------------------------------------------------
  specification public macros
  -----------------------------------------------------------------------------
 */
// all and nothing
#define DBMMaskAll_CN50                 ((tsp00_Uint4) 0xFFFFFFFF)
#define DBMMaskNothing_CN50             ((tsp00_Uint4) 0x00000000)

// server rights
#define DBMRightUserMgm_CN50            ((tsp00_Uint4) 0x00000001)
#define DBMRightInstallMgm_CN50         ((tsp00_Uint4) 0x00000002)
#define DBMRightSystemCmd_CN50          ((tsp00_Uint4) 0x00000004)
#define DBMRightFileFull_CN50           ((tsp00_Uint4) 0x00000008)
#define DBMRightFileRead_CN50           ((tsp00_Uint4) 0x00000010)
#define DBMRightDBFileRead_CN50         ((tsp00_Uint4) 0x00000020)
#define DBMRightAccessUtility_CN50      ((tsp00_Uint4) 0x00000040)
#define DBMRightBackupRestore_CN50      ((tsp00_Uint4) 0x00000080)
#define DBMRightBackupSave_CN50         ((tsp00_Uint4) 0x00000100)
#define DBMRightParamFull_CN50          ((tsp00_Uint4) 0x00000200)
#define DBMRightParamCheckWrite_CN50    ((tsp00_Uint4) 0x00000400)
#define DBMRightUnused11_CN50           ((tsp00_Uint4) 0x00000800)
#define DBMRightUnused12_CN50           ((tsp00_Uint4) 0x00001000)
#define DBMRightParamRead_CN50          ((tsp00_Uint4) 0x00002000)
#define DBMRightAccessSQL_CN50          ((tsp00_Uint4) 0x00004000)
#define DBMRightExecLoad_CN50           ((tsp00_Uint4) 0x00008000)
#define DBMRightLoadSysTab_CN50         ((tsp00_Uint4) 0x00010000)
#define DBMRightDBStop_CN50             ((tsp00_Uint4) 0x00020000)
#define DBMRightDBStart_CN50            ((tsp00_Uint4) 0x00040000)
#define DBMRightDBInfoRead_CN50         ((tsp00_Uint4) 0x00080000)
#define DBMRightUnused20_CN50           ((tsp00_Uint4) 0x00100000)
#define DBMRightUnused21_CN50           ((tsp00_Uint4) 0x00200000)
#define DBMRightUnused22_CN50           ((tsp00_Uint4) 0x00400000)
#define DBMRightUnused23_CN50           ((tsp00_Uint4) 0x00800000)
#define DBMRightUnused24_CN50           ((tsp00_Uint4) 0x01000000)
#define DBMRightUnused25_CN50           ((tsp00_Uint4) 0x02000000)
#define DBMRightUnused26_CN50           ((tsp00_Uint4) 0x04000000)
#define DBMRightUnused27_CN50           ((tsp00_Uint4) 0x08000000)
#define DBMRightUnused28_CN50           ((tsp00_Uint4) 0x10000000)
#define DBMRightUnused29_CN50           ((tsp00_Uint4) 0x20000000)
#define DBMRightUnused30_CN50           ((tsp00_Uint4) 0x40000000)
#define DBMRightUnused31_CN50           ((tsp00_Uint4) 0x80000000)

// GUI rights
#define DBMGUIRight01_CN50              ((tsp00_Uint4) 0x00000001)
#define DBMGUIRight02_CN50              ((tsp00_Uint4) 0x00000002)
#define DBMGUIRight03_CN50              ((tsp00_Uint4) 0x00000004)
#define DBMGUIRight04_CN50              ((tsp00_Uint4) 0x00000008)
#define DBMGUIRight05_CN50              ((tsp00_Uint4) 0x00000010)
#define DBMGUIRight06_CN50              ((tsp00_Uint4) 0x00000020)
#define DBMGUIRight07_CN50              ((tsp00_Uint4) 0x00000040)
#define DBMGUIRight08_CN50              ((tsp00_Uint4) 0x00000080)
#define DBMGUIRight09_CN50              ((tsp00_Uint4) 0x00000100)
#define DBMGUIRight10_CN50              ((tsp00_Uint4) 0x00000200)
#define DBMGUIRight11_CN50              ((tsp00_Uint4) 0x00000400)
#define DBMGUIRight12_CN50              ((tsp00_Uint4) 0x00000800)
#define DBMGUIRight13_CN50              ((tsp00_Uint4) 0x00001000)
#define DBMGUIRight14_CN50              ((tsp00_Uint4) 0x00002000)
#define DBMGUIRight15_CN50              ((tsp00_Uint4) 0x00004000)
#define DBMGUIRight16_CN50              ((tsp00_Uint4) 0x00008000)
#define DBMGUIRight17_CN50              ((tsp00_Uint4) 0x00010000)
#define DBMGUIRight18_CN50              ((tsp00_Uint4) 0x00020000)
#define DBMGUIRight19_CN50              ((tsp00_Uint4) 0x00040000)
#define DBMGUIRight20_CN50              ((tsp00_Uint4) 0x00080000)
#define DBMGUIRight21_CN50              ((tsp00_Uint4) 0x00100000)
#define DBMGUIRight22_CN50              ((tsp00_Uint4) 0x00200000)
#define DBMGUIRight23_CN50              ((tsp00_Uint4) 0x00400000)
#define DBMGUIRight24_CN50              ((tsp00_Uint4) 0x00800000)
#define DBMGUIRight25_CN50              ((tsp00_Uint4) 0x01000000)
#define DBMGUIRight26_CN50              ((tsp00_Uint4) 0x02000000)
#define DBMGUIRight27_CN50              ((tsp00_Uint4) 0x04000000)
#define DBMGUIRight28_CN50              ((tsp00_Uint4) 0x08000000)
#define DBMGUIRight29_CN50              ((tsp00_Uint4) 0x10000000)
#define DBMGUIRight30_CN50              ((tsp00_Uint4) 0x40000000)
#define DBMGUIRight31_CN50              ((tsp00_Uint4) 0x80000000)


// default for dbm user
#define DBMUserDefaultGUI_CN50          ((tsp00_Uint4) DBMMaskNothing_CN50)
#define DBMUserDefault_CN50             ((tsp00_Uint4) DBMRightUserMgm_CN50            + \
                                                       DBMRightInstallMgm_CN50         + \
                                                       DBMRightSystemCmd_CN50          + \
                                                       DBMRightFileFull_CN50           + \
                                                       DBMRightFileRead_CN50           + \
                                                       DBMRightDBFileRead_CN50         + \
                                                       DBMRightAccessUtility_CN50      + \
                                                       DBMRightBackupRestore_CN50      + \
                                                       DBMRightBackupSave_CN50         + \
                                                       DBMRightParamFull_CN50          + \
                                                       DBMRightParamCheckWrite_CN50    + \
                                                       DBMRightParamRead_CN50    + \
                                                       DBMRightAccessSQL_CN50          + \
                                                       DBMRightExecLoad_CN50           + \
                                                       DBMRightLoadSysTab_CN50         + \
                                                       DBMRightDBStop_CN50             + \
                                                       DBMRightDBStart_CN50            + \
                                                       DBMRightDBInfoRead_CN50)

// default for superuser
#define SuperUserDefaultGUI_CN50        ((tsp00_Uint4) DBMMaskNothing_CN50)
#define SuperUserDefault_CN50           ((tsp00_Uint4) DBMRightUserMgm_CN50            + \
                                                       DBMRightInstallMgm_CN50         + \
                                                       DBMRightSystemCmd_CN50          + \
                                                       DBMRightFileFull_CN50           + \
                                                       DBMRightFileRead_CN50           + \
                                                       DBMRightDBFileRead_CN50         + \
                                                       DBMRightAccessUtility_CN50      + \
                                                       DBMRightBackupRestore_CN50      + \
                                                       DBMRightBackupSave_CN50         + \
                                                       DBMRightParamFull_CN50          + \
                                                       DBMRightParamCheckWrite_CN50    + \
                                                       DBMRightParamRead_CN50       + \
                                                       DBMRightAccessSQL_CN50          + \
                                                       DBMRightExecLoad_CN50           + \
                                                       DBMRightLoadSysTab_CN50         + \
                                                       DBMRightDBStop_CN50             + \
                                                       DBMRightDBStart_CN50            + \
                                                       DBMRightDBInfoRead_CN50)

// default for operator
#define OperatorUserDefaultGUI_CN50     ((tsp00_Uint4) DBMMaskNothing_CN50)
#define OperatorUserDefault_CN50        ((tsp00_Uint4) DBMRightBackupRestore_CN50      + \
                                                       DBMRightBackupSave_CN50         + \
                                                       DBMRightDBStop_CN50             + \
                                                       DBMRightDBStart_CN50            + \
                                                       DBMRightDBInfoRead_CN50)

// some defualt users
#define USERNAME_DOMAIN_CN50    (*(tsp00_UserNamec *) _T("domain"))
#define USERNAME_OPERATOR_CN50  (*(tsp00_UserNamec *) _T("operator"))
#define USERNAME_SUPERUSER_CN50 (*(tsp00_UserNamec *) _T("superuser"))


// Record identifier
#define UserRecordFormat_1_CN50                        ((tsp00_Uint4) 1)

#define UserRecordFormat_Curr_CN50                     UserRecordFormat_1_CN50

/*
  -----------------------------------------------------------------------------
  forward deklarations
  -----------------------------------------------------------------------------
 */
class teo28_ProfileContainer;

/*!
  -----------------------------------------------------------------------------
  Class:        cn50DBMUser
  -----------------------------------------------------------------------------

  description:  DBM User Object

                An instance of this class represents an User of the
                database instance
                
  -----------------------------------------------------------------------------
 */
class cn50DBMUser
{
  public:
    typedef enum {
      SQLUsrModeDBA,
      SQLUsrModeRESOURCE,
      SQLUsrModeSTANDARD
    } SQLUserMode;


    /*!  
      Chapter: Construction and destruction of class
     */

    /*!
      -------------------------------------------------------------------------
      function:     cn50DBMUser
      -------------------------------------------------------------------------
      description:  Default constructor

                    This constructor without parameters initializes a
                    empty user object.

      -------------------------------------------------------------------------
     */
     cn50DBMUser();

    /*!
      -------------------------------------------------------------------------
      function:     cn50DBMUser
      -------------------------------------------------------------------------
      description:  "Read"-Constructor

                    This constructor loads the specified user from the 
                    user data container. If there are no user data available
                    an empty user object will be created an existsOnDisk()
                    returns false.

      arguments:    szDBName   [IN] - the name of the database
                    szUserName [IN] - the name of the user
      -------------------------------------------------------------------------
     */
     cn50DBMUser(tsp00_DbNamec const szDBName, tsp00_UserNamec const szUserName);

    /*!  
      EndChapter: Construction and destruction of class
     */

    /*!  
      Chapter: Write data to object
     */

    /*!
      -------------------------------------------------------------------------
      function:     setDBName
      -------------------------------------------------------------------------
      description:  set the name of the database instance

      arguments:    szValue    [IN] - database name
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setDBName       ( tsp00_DbNamec   const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setUserName
      -------------------------------------------------------------------------
      description:  set the name of the user

      arguments:    szValue    [IN] - user name

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setUserName     ( tsp00_UserNamec const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setMasterPwd
      -------------------------------------------------------------------------
      description:  set the first (master) password of the user

      arguments:    szValue    [IN] - passsword

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setMasterPwd    ( tsp00_Namec     const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setSecondPwd
      -------------------------------------------------------------------------
      description:  set the second password of the user

      arguments:    szValue    [IN] - passsword

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSecondPwd    ( tsp00_Namec     const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setSystemName
      -------------------------------------------------------------------------
      description:  set the name of the os user

      arguments:    szValue    [IN] - os user

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSystemName   ( tsp00_UserNamec const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setSystemPwd
      -------------------------------------------------------------------------
      description:  set the password of the os user

      arguments:    szValue    [IN] - os password

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSystemPwd    ( tsp00_Namec     const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     setDBMUser
      -------------------------------------------------------------------------
      description:  set DBMUser flag

                    DBMUser means, the right "using the DBMServer" is
                    granted to this user

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setDBMUser      ( bool const bValue = true );

    /*!
      -------------------------------------------------------------------------
      function:     setSQLUser
      -------------------------------------------------------------------------
      description:  set SQLUser flag

                    SQLUser means, this user exists also in the database

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSQLUser      ( bool const bValue = true );

    /*!
      -------------------------------------------------------------------------
      function:     setColdUser
      -------------------------------------------------------------------------
      description:  set ColdUser flag

                    ColdUser means, this is the user for operations at
                    the cold kernel

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setColdUser     ( bool const bValue = true );

    /*!
      -------------------------------------------------------------------------
      function:     setExistsInDB
      -------------------------------------------------------------------------
      description:  set the ExistsInDBFlag flag

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setExistsInDB ( bool bValue = true);

    /*!
      -------------------------------------------------------------------------
      function:     setSDBAUser
      -------------------------------------------------------------------------
      description:  set SDBAUser flag

                    SDBAUser means, this is the user used on
                    "ACTIVATE SERVERDB"

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSDBAUser     ( bool const bValue = true );

    /*!
      -------------------------------------------------------------------------
      function:     setSQLUsermode
      -------------------------------------------------------------------------
      description:  set the sql user mode

      arguments:    eValue    [IN] - new unser mode (SQLUsrModeDBA, 
                                     SQLUsrModeRESOURCE, SQLUsrModeSTANDARD)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setSQLUsermode  ( cn50DBMUser::SQLUserMode const eValue );

    /*!
      -------------------------------------------------------------------------
      function:     setDisabled
      -------------------------------------------------------------------------
      description:  enable/disable account

      arguments:    bValue    [IN] - new value for flag (default = true)

      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setDisabled     ( bool const bValue = true );

    /*!
      -------------------------------------------------------------------------
      function:     setServerRights
      -------------------------------------------------------------------------
      description:  set rights for server access

      arguments:    nMask     [IN] - only the right in this mask will be 
                                     affected (DBMRight*_CN50 - values)
                    nValues   [IN] - the new values for the rights specified
                                     in nMask (DBMRight*_CN50 - values)
      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setServerRights ( tsp00_Uint4 const nMask, tsp00_Uint4 const nValues );

    /*!
      -------------------------------------------------------------------------
      function:     setGUIRights
      -------------------------------------------------------------------------
      description:  set rights for GUI access

      arguments:    nMask     [IN] - only the right in this mask will be 
                                     affected (DBMRightGUI*_CN50 - values)
                    nValues   [IN] - the new values for the rights specified
                                     in nMask (DBMRightGUI*_CN50 - values)
      return value: the C++ object
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setGUIRights    ( tsp00_Uint4 const nMask, tsp00_Uint4 const nValues );

    /*!
      -------------------------------------------------------------------------
      function:     setData
      -------------------------------------------------------------------------
      description:  set the user data by data string

                    Format of data string is
                    <property>=<value> <property>=<value> ...
                    Properties are:
                      SERVERRIGHTS  
                      GUIRIGHTS     
                      PASSWORD      
                      SECONDPASSWORD
                      SYSTEMNAME    
                      SYSTEMPASSWORD
                      DBMUSER       
                      SQLUSER

                    For server rights use the logical names with + or -
                    e.g. SERVERRIGHTS=+LoadSysTab,-AccessSQL
                    grants the right "LoadSysTab" and removes the
                    right "AccessSQL"

      arguments:    szData    [IN] - data string

      return value: DBMServer Error-Code
      -------------------------------------------------------------------------
     */
     tcn00_Error setData ( const _TCHAR * szData );
     
    /*!
      -------------------------------------------------------------------------
      function:     setComment
      -------------------------------------------------------------------------
      description:  set the comment 

      arguments:    szValue    [IN] - database name
      -------------------------------------------------------------------------
     */
     cn50DBMUser & setComment      ( tsp00_C64c      const szValue );

    /*!  
      EndChapter: Write data to object
     */

    /*!  
      Chapter: Use object data
     */

    /*!
      -------------------------------------------------------------------------
      function:     checkMasterPwd
      -------------------------------------------------------------------------
      description:  check the first (master) password  of the user

                    check will fail if the user is disbaled

      arguments:    szValue   [IN] - password

      return value: true on success, otherwise false
      -------------------------------------------------------------------------
     */
     bool           checkMasterPwd  ( tsp00_Namec     const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     checkSecondPwd
      -------------------------------------------------------------------------
      description:  check the second password of the user

                    check will fail if the user is disbaled or there is
                    no second password

      arguments:    szValue   [IN] - password

      return value: true on success, otherwise false
      -------------------------------------------------------------------------
     */
     bool           checkSecondPwd  ( tsp00_Namec     const szValue );

    /*!
      -------------------------------------------------------------------------
      function:     getDBName
      -------------------------------------------------------------------------
      description:  read database name

      return value: database name
      -------------------------------------------------------------------------
     */
     tsp00_DbNamec    getDBName       ( ) const; 

    /*!
      -------------------------------------------------------------------------
      function:     getUserName
      -------------------------------------------------------------------------
      description:  read user name

      return value: user name
      -------------------------------------------------------------------------
     */
     tsp00_UserNamec  getUserName     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getMasterPwd
      -------------------------------------------------------------------------
      description:  read the first (master) password

      return value: password (appl-crypted or clear )

      prototypes:   2
      -------------------------------------------------------------------------
     */
     tsp00_CryptPw    getMasterPwd    ( ) const;
     tsp00_C64c       getMasterPwd    ( bool bUncrypt ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getClearMasterPwd
      -------------------------------------------------------------------------
      description:  read the first (master) password

      return value: clear password
      -------------------------------------------------------------------------
     */
     tsp00_Namec      getClearMasterPwd    ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getSecondPwd
      -------------------------------------------------------------------------
      description:  read the second password

      return value: password (appl-crypted)

      prototypes:   2
      -------------------------------------------------------------------------
     */
     tsp00_CryptPw    getSecondPwd    ( ) const;
     tsp00_C64c       getSecondPwd    ( bool bUncrypt ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isSecondPwd
      -------------------------------------------------------------------------
      description:  is there a second password

      return value: true on success, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isSecondPwd     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getSystemName
      -------------------------------------------------------------------------
      description:  read os user name

      return value: os user name
      -------------------------------------------------------------------------
     */
     tsp00_UserNamec  getSystemName   ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getSystemPwd
      -------------------------------------------------------------------------
      description:  read the os password

      return value: password (appl-crypted or clear )

      prototypes:   2
      -------------------------------------------------------------------------
     */
     tsp00_CryptPw    getSystemPwd    ( ) const;
     tsp00_C64c       getSystemPwd    ( bool bUncrypt ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isDBMUser
      -------------------------------------------------------------------------
      description:  read DBMUser flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isDBMUser       ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isSQLUser
      -------------------------------------------------------------------------
      description:  read SQLUser flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isSQLUser       ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isColdUser
      -------------------------------------------------------------------------
      description:  read ColdUser flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isColdUser     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isSDBAUser
      -------------------------------------------------------------------------
      description:  read SDBAUser flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isSDBAUser     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getSQLUsermode
      -------------------------------------------------------------------------
      description:  get the sql user mode

      return value: user mode (SQLUsrModeDBA, SQLUsrModeRESOURCE, SQLUsrModeSTANDARD)

      -------------------------------------------------------------------------
     */
     cn50DBMUser::SQLUserMode  getSQLUsermode  ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isSQLDba
      -------------------------------------------------------------------------
      description:  read SQL Dba  flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isSQLDba       ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isDisabled
      -------------------------------------------------------------------------
      description:  read disabled flag

      return value: value of flag
      -------------------------------------------------------------------------
     */
     bool           isDisabled     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getServerRights
      -------------------------------------------------------------------------
      description:  read the server rights bitfield

      return value: server rights
      -------------------------------------------------------------------------
     */
     tsp00_Uint4      getServerRights ( ) const;
    
    /*!
      -------------------------------------------------------------------------
      function:     getGUIRights
      -------------------------------------------------------------------------
      description:  read the GUI rights bitfield

      return value: GUI rights
      -------------------------------------------------------------------------
     */
     tsp00_Uint4      getGUIRights    ( ) const;
    
    /*!
      -------------------------------------------------------------------------
      function:     isServerRight
      -------------------------------------------------------------------------
      description:  check if server right is set

      arguments:    nRights   [IN] - rights to check
                    bAnd      [IN] - return true only, if all rights specified
                                     in nRight are set (default false - returns
                                     true if only one right is set)

      return value: true on success, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isServerRight   ( tsp00_Uint4 const nRights, bool const bAnd = false ) const;
    
    /*!
      -------------------------------------------------------------------------
      function:     isGUIRight
      -------------------------------------------------------------------------
      description:  check if GUI right is set

      arguments:    nRights   [IN] - rights to check
                    bAnd      [IN] - return true only, if all rights specified
                                     in nRight are set (default false - returns
                                     true if only one right is set)

      return value: true on success, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isGUIRight      ( tsp00_Uint4 const nRights, bool const bAnd = false ) const;

    /*!
      -------------------------------------------------------------------------
      function:     getComment
      -------------------------------------------------------------------------
      description:  read comment      

      return value: comment      
      -------------------------------------------------------------------------
     */
     tsp00_C64c       getComment      ( ) const; 
    /*!
      -------------------------------------------------------------------------
      function:     getData
      -------------------------------------------------------------------------
      description:  read user data for DBMServer answer

      arguments:    pBuffer  [OUT] - buffer for the data
      -------------------------------------------------------------------------
     */
     void           getData         ( _TCHAR * pBuffer ) const; 

    /*!
      -------------------------------------------------------------------------
      function:     getUPCOwner
      -------------------------------------------------------------------------
      description:  read the owner of UPC

      return value: user name
      -------------------------------------------------------------------------
     */
     tsp00_UserNamec  getUPCOwner     ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     listRights
      -------------------------------------------------------------------------
      description:  read user data for DBMServer answer

      arguments:    pBuffer  [OUT] - buffer for the data
                    szMode   [IN]  - buffer with "SERVERRIGHTS" for server rights
                                     or "GUIRIGHTS" for GUI rights
     return value: DBMServer Error-Code
      -------------------------------------------------------------------------
     */
     tcn00_Error    listRights      ( _TCHAR * pBuffer, const _TCHAR * szMode ) const; 

    /*!  
      EndChapter: Use object data
     */

    /*!  
      Chapter: Object state
     */

    /*!
      -------------------------------------------------------------------------
      function:     existsOnDisk
      -------------------------------------------------------------------------
      description:  is this user saved on disk?

      return value: true if saved, otherwise false
      -------------------------------------------------------------------------
     */
     bool           existsOnDisk    ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     existsInDB
      -------------------------------------------------------------------------
      description:  exists the user in the database

      return value: true if exists, otherwise false
      -------------------------------------------------------------------------
     */
     bool          existsInDB  ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isDirty
      -------------------------------------------------------------------------
      description:  is this user dirty?

                    That means: Hold the object unsaved data in the memory?

      return value: true if dirty, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isDirty         ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     isLoggedOn
      -------------------------------------------------------------------------
      description:  is this user logged on

      return value: true if yes, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isLoggedOn      ( ) const;

    /*!
      -------------------------------------------------------------------------
      function:     clear
      -------------------------------------------------------------------------
      description:  clear all data
      -------------------------------------------------------------------------
     */
     void           clear           ( );

    /*!
      -------------------------------------------------------------------------
      function:     isThis
      -------------------------------------------------------------------------
      description:  is this the user

      arguments:    szUserName - name to check

      return value: true if dirty, otherwise false
      -------------------------------------------------------------------------
     */
     bool           isThis         ( tsp00_UserNamec const szUserName) const;

    /*!  
      EndChapter: Object state
     */

    /*!  
      Chapter: Disk access
     */

    /*!
      -------------------------------------------------------------------------
      function:     save
      -------------------------------------------------------------------------
      description:  save user to disk

      arguments:    bRecover - Recovery mode - create only upc entry

      return value: DBMServer Error-Code
      -------------------------------------------------------------------------
     */
     tcn00_Error    save            ( bool bRecover = false );

    /*!
      -------------------------------------------------------------------------
      function:     reload
      -------------------------------------------------------------------------
      description:  read user from disk 

                    Unsaved data will be overwritten!

      return value: DBMServer Error-Code
      -------------------------------------------------------------------------
     */
     tcn00_Error    reload          ( );

    /*!
      -------------------------------------------------------------------------
      function:     deleteUsr
      -------------------------------------------------------------------------
      description:  delete this user entry at the disk

      return value: DBMServer Error-Code
      -------------------------------------------------------------------------
     */
     tcn00_Error    deleteUsr       ( );

    /*!  
      EndChapter: Disk access
     */

// always constant header format
    typedef struct DBMUserHeader_Tag {
        tsp00_Uint2      nRecordId;
        tsp00_Uint2      nRecordSize;
    } DBMUserHeader;

// current record format version 1
    typedef struct DBMUserData_1_Tag {
      DBMUserHeader   recHeader;

      tsp00_Uint2      s_szDBName;
      tsp00_DbNamec    szDBName;

      tsp00_Uint2      s_szUserName;
      tsp00_UserNamec  szUserName;

      tsp00_Uint2      s_cryptMasterPwd;
      tsp00_CryptPw    cryptMasterPwd;

      tsp00_Uint2      s_cryptSecondPwd;
      tsp00_CryptPw    cryptSecondPwd;

      tsp00_Uint2      s_szSystemName;
      tsp00_UserNamec  szSystemName;

      tsp00_Uint2      s_cryptSystemPwd;
      tsp00_CryptPw    cryptSystemPwd;

      tsp00_Uint2      s_bSecondPwd;
      bool             bSecondPwd;

      tsp00_Uint2      s_bDBMUser;
      bool             bDBMUser;

      tsp00_Uint2      s_bSQLUser;
      bool             bSQLUser;

      tsp00_Uint2      s_bExistsInDB;
      bool             bExistsInDB;

      tsp00_Uint2      s_bColdUser;
      bool             bColdUser;

      tsp00_Uint2      s_bSDBAUser;
      bool             bSDBAUser;

      tsp00_Uint2      s_eUserMode;
      SQLUserMode      eUserMode;

      tsp00_Uint2      s_bDisabled;
      bool             bDisabled;

      tsp00_Uint2      s_dbmServerRights;
      tsp00_Uint4      dbmServerRights;

      tsp00_Uint2      s_dbmGUIRights;
      tsp00_Uint4      dbmGUIRights;

      tsp00_Uint2      s_szComment;
      tsp00_C64c       szComment;

    } DBMUserData_1;

  protected:

    DBMUserData_1  Data;

    tsp00_UserNamec  szUPCOwner;

    bool           bExistsOnDisk;
    bool           bDirty;
    bool           bPwdDirty;
    bool           bSecondPwdDirty;
    bool           bSQLDirty;

    bool           bLoggedOn;

    typedef struct RightToTextT {
      tsp00_Int4     nRight;
      const _TCHAR * szName;
      const _TCHAR * szDescription;
    } RightToTextT;

    cn50DBMUser & setRights     ( _TCHAR * szValue, tsp00_Uint4 & nValue, RightToTextT RightList[] );
    tcn00_Error   saveColdUsr   ( );
    tcn00_Error   saveSQLUsr    ( );
    tcn00_Error   deleteSQLUsr  ( );
    void          setSizes      ( DBMUserData_1 & Data ) const;

// Handling of old record formats

    tcn00_Error   checkRecord   ( const tsp00_UserNamec    szUserName,
                                  teo28_ProfileContainer * pProfile,
                                  const DBMUserData_1    * pHeader ) const;

    tcn00_Error   convFrom0To1  ( const tsp00_UserNamec    szUserName,
                                  teo28_ProfileContainer * pProfile ) const;

    tcn00_Error   convFromXToX  ( const tsp00_UserNamec    szUserName,
                                  teo28_ProfileContainer * pProfile ) const;

// old record format version 0
  public:
    typedef struct  DBMUserData_0_Tag {
      tsp00_DbNamec    szDBName;
      tsp00_UserNamec  szUserName;
      tsp00_CryptPw    cryptMasterPwd;
      tsp00_CryptPw    cryptSecondPwd;
      tsp00_UserNamec  szSystemName;
      tsp00_CryptPw    cryptSystemPwd;
      bool             bSecondPwd;
      bool             bDBMUser;
      bool             bSQLUser;
      bool             bExistsInDB;
      bool             bColdUser;
      bool             bSDBAUser;
      SQLUserMode      eUserMode;
      bool             bDisabled;
      tsp00_Uint4      dbmServerRights;
      tsp00_Uint4      dbmGUIRights;
      tsp00_C64c       szComment;

    } DBMUserData_0;

}; // end class cn50DBMUser

/*! EndClass: cn50DBMUser */

#endif /* _HCN50_H_ */
