/*!***************************************************************************

  module      : hco83ErrorHandling.h

  -------------------------------------------------------------------------

  responsible : FerdiF

  special area: IDL to Code Generator   
  description : Error Handling
				
  
  last changed: 2000-03-08  11:22
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef HCO83ERRORHANDLING_H
#define HCO83ERRORHANDLING_H

#define C_WRONG_PARAMETERS_CO83        1
#define C_XML_PARSE_ERROR_CO83         2
#define C_P1_NO_USERDEFINED_TYPE_CO83  3
#define C_P1_IO_TYPE_INPUT_CO83        4
#define C_P1_IO_TYPE_OUTPUT_CO83       5
#define C_P1_WRONG_GUID_CO83           6
#define C_P1_NO_GUID_CO83              7
#define C_P1_TYPE_SPEC_INCOMPLETE_CO83 8
#define C_TYPE_UNKNOWN_CO83            9
#define C_UNSUPPORTED_VT_CARRAY1_CO83  10
#define C_NO_DIR_SPECIFIC_CO83         11
#define C_PASS_STRUCT_BY_PTR_CO83      12
#define C_IN_SCALAR_BYPTR_CO83         13
#define C_UNSUPPORTED_PARAM_TYPE_CO83  14
#define C_PTR_OF_PTR_UNSUPPORTED_CO83  15
#define C_UNSUPPORTED_VT_CARRAY2_CO83  16
#define C_TYPE_NOT_PORTABLE_CO83       17
#define C_STRUCT_NOT_ALIGNED_CO83      18
#define C_POINTER_NOT_ALLOWED_CO83     19
#define C_DIMENSION_TYPE_UNDEF_CO83    20
#define C_CONST_EXPR_NOT_VALID_CO83    21
#define C_DUP_DEFINITION_CO83          22

#define C_NUMBER_OF_ERROR_CO83         22

void co83ErrorMsg( const int err_no );
void co83ErrorMsg( const int err_no, const char* p1 );
void co83ErrorMsg( const int err_no, const char* p1, const int p2 );
void co83ErrorMsg( const int err_no, const char* p1, const char* p2 );
void co83ErrorMsg( const int err_no, const char* p1, const char* p2, const char* p3 );
void co83WarnMsg( const int err_no, const char* p1, const char* p2 );
void co83WarnMsg( const int err_no, const char* p1, const char* p2, const char* p3 );

#endif
