/* @lastChanged: "1999-04-21"
/* @filename:    vco61.cpp
 * @purpose:     "LiveCacheProxy: Implementation of 'Debug' Method"
 * @release:     7.2.0.0
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "hco62.h"
#include "hco60.h"
#include "hco61.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#ifdef NO_INLINES
# define _INLINE
#else
# define _INLINE	inline
#endif



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



/*===========================================================================*
 *  GLOBAL VARIABLES                                                         *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL VARIABLES                                                          *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL FUNCTIONS (PROTOTYPES)                                             *
 *===========================================================================*/



/*===========================================================================*
 *  GLOBAL FUNCTIONS (CODE)                                                  *
 *===========================================================================*/

STDMETHODIMP CliveCacheDbg::Debug(long DbgpBufSize, long * DbgpBufLength, unsigned char * pDbgBuffer,
                                  long DbgpBufSize2, long * DbgpBufLength2, unsigned char * pDbgBuffer2)
{
    teo39_DebugMsg *p = (teo39_DebugMsg *) pDbgBuffer;
    HANDLE          hEventArray[1];
	DWORD			WaitRc;

    switch (p->dbghdr.hdbgMsgKind)
    {
        case vdcomRequest_eo39:
        case iSinkReply_eo39:
            m_buffer_ptr    = pDbgBuffer;
            m_buffer_ptr2   = pDbgBuffer2;
            m_DbgBuf2Length = *DbgpBufLength2;
            SetEvent(m_hCoRequestEvent) ;
            hEventArray[0] = m_hCoReplyEvent;

		    WaitRc = ::WaitForMultipleObjects(1,
		                                      hEventArray,
		                                      FALSE,
		                                      INFINITE);

		    switch(WaitRc)
			{
			    case WAIT_OBJECT_0:
					p = (teo39_DebugMsg *) m_buffer_ptr;
				    *DbgpBufLength = p->dbghdr.hdbgBufLen;
					memcpy(pDbgBuffer,m_buffer_ptr,*DbgpBufLength);
                    if (m_DbgBuf2Length)
                    {
                        *DbgpBufLength2 = m_DbgBuf2Length; 
                        if ( pDbgBuffer2 != m_buffer_ptr2 )
                            memcpy(pDbgBuffer2,m_buffer_ptr2,m_DbgBuf2Length);
                    }
                    break;
			    case WAIT_OBJECT_0 + 1:         
			    case WAIT_TIMEOUT:
			    default:
                    break;
            }
            break;
        case vdcomReply_eo39:
        case iSinkRequest_eo39: 
            // error
            break;
    }

	return S_OK;
}

/*===========================================================================*
 *  LOCAL FUNCTIONS (CODE)                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/