/* @lastChanged: "1999-04-21  10:12"
 * @filename:    vco63.cpp
 * @purpose:     "LiveCacheProxy: DCOM-Apartment-Thread"
 * @release:     7.2.0.0
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "hco62.h"
#include "hco60.h"
#include "hco61.h"
#include "hco63.h"
#include "vsp001.h"
#include "heo36.h"
#include "heo38.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#ifdef NO_INLINES
# define _INLINE
#else
# define _INLINE	inline
#endif


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL CLASSES, STRUCTURES, TYPES, UNIONS ...                             *
 *===========================================================================*/



/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



/*===========================================================================*
 *  GLOBAL VARIABLES                                                         *
 *===========================================================================*/


/*===========================================================================*
 *  LOCAL VARIABLES                                                          *
 *===========================================================================*/



/*===========================================================================*
 *  LOCAL FUNCTIONS (PROTOTYPES)                                             *
 *===========================================================================*/



/*===========================================================================*
 *  GLOBAL FUNCTIONS (CODE)                                                  *
 *===========================================================================*/

extern "C" void  sqlabort(){int x=0; x=1/x;};
void  sql__caseerr(){int x=0; x=x/1;};
long  sqlk_rangeviolation ( long              val,
                           long              minVal,
                           long              maxVal,
                           int               lineno,
                           const char       *fileName)
{ int x=0; x=x/1; return -1; };

DWORD __stdcall DBProcThread(void* pv)
{
  HRESULT         hr;
  CliveCacheDbg*  pLCD;
  HANDLE          hEventArray[2];
  bool            bContinue = true;
  long            lWaitTime = 50000;  // Milliseconds
  teo39_DebugMsg  *p;
  tsp00_Addr      pSession;
  tsp_dcom_release_instance_parms   ReleaseParms;
  teo39_TStack*   ptr_tstack; 
  int             len, outlen;
  short           param_cnt; 
  teo39_TStack*   ptr_paramStack;
  unsigned char*  ptr_param;
  unsigned char*  ptr_inonly_param;
  unsigned char*  ptr_inbuf;
  tsp1_packet_ptr packet_ptr;
  tsp00_Int4      paramStackLen, i;
  teo39_Transend* lpstack;  
  
  // Initialize the COM Library.
  hr = CoInitializeEx(0, COINIT_MULTITHREADED);
  
  pLCD = reinterpret_cast<CliveCacheDbg*>(pv);
  
  eo38VDcomInitSink(&pLCD->m_sink_parms);
  hEventArray[0] = pLCD->m_hCoRequestEvent;
  hEventArray[1] = pLCD->m_hStopThreadEvent;
  
  while (bContinue)
  {
    switch(::WaitForMultipleObjects(2,
      hEventArray,
      FALSE,
      INFINITE)) 
    {
    case WAIT_OBJECT_0:
      p = (teo39_DebugMsg*) pLCD->m_buffer_ptr;
      switch ( p->dbgMsgParm.pdbgKind )
      {
      case vdcomSetEnvironment_os39:        /* PTS 1107355 FF 21-Aug-2000 */
        SetEnvironmentVariable( "DBROOT", p->dbgMsgParm.v.SetEnvironment.envStr );
        p->dbghdr.hdbgBufLen  = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind)  + 
          sizeof(teo39_vdcomReleaseAll_rply);
        p->dbgMsgParm.v.ReleaseAll_rplyP.hr = 0;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case vdcom_paraminfo_eo39:
        
        len = p->dbghdr.hdbgBufLen;
        memcpy ( pLCD->m_DbprocParms, p, len );
        
        memcpy(&pSession, &p->dbgMsgParm.v.ParamInfoP.session, 
							   sizeof(p->dbgMsgParm.v.ParamInfoP.session));
        
        memcpy(&pLCD->m_DbprocParms->dbgMsgParm.v.ParamInfoP.session, 
          &pLCD->m_sink_parms.sink_addr, 
          sizeof(pLCD->m_DbprocParms->dbgMsgParm.v.ParamInfoP.session));
        ptr_param = (unsigned char*)pLCD->m_DbprocParms;
        ptr_param = ptr_param + sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind) + 
          sizeof(tsp_dcom_paraminfo_parms);
        pLCD->m_DbprocParms->dbgMsgParm.v.ParamInfoP.packet = (tsp_moveobj*)ptr_param;
        eo36ParamInfo( &pLCD->m_DbprocParms->dbgMsgParm.v.ParamInfoP );
        len = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind) + 
          sizeof(tsp_dcom_paraminfo_parms);
        len = len + sizeof(tsp1_packet_header) +
          ((tsp1_packet_ptr)pLCD->m_DbprocParms->dbgMsgParm.v.ParamInfoP.packet)->sp1_header.sp1h_varpart_len;
        memcpy (p, pLCD->m_DbprocParms, len );
        memcpy(&p->dbgMsgParm.v.ParamInfoP.session[0], &pSession, 
          sizeof(p->dbgMsgParm.v.ParamInfoP.session));
        ptr_param = (unsigned char*)p;
        ptr_param = ptr_param + sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind) + 
          sizeof(tsp_dcom_paraminfo_parms);
        packet_ptr      = (tsp1_packet_ptr)ptr_param;
        pLCD->m_DbgBuf2Length = 0;
        p->dbghdr.hdbgBufLen = len;
        break;
      case vdcomGetDispaddr_eo39:
        pSession = p->dbgMsgParm.v.CoCreateP.ikernel_sink;
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pLCD->m_sink_parms.sink_addr;
        len = p->dbghdr.hdbgBufLen;
        memcpy ( pLCD->m_DbprocParms, p, len );
        eo38VDcomGetDispAddr( &pLCD->m_DbprocParms->dbgMsgParm.v.CoCreateP );
        len = p->dbghdr.hdbgBufLen;
        memcpy ( p, pLCD->m_DbprocParms, len );
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pSession;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case coGetClassObject_eo39:
        pSession = p->dbgMsgParm.v.CoCreateP.ikernel_sink;
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pLCD->m_sink_parms.sink_addr;
        len = p->dbghdr.hdbgBufLen;
        memcpy ( pLCD->m_DbprocParms, p, len );
        eo38CoGetClassObject( &pLCD->m_DbprocParms->dbgMsgParm.v.CoCreateP );
        len = p->dbghdr.hdbgBufLen;
        memcpy ( p, pLCD->m_DbprocParms, len );
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pSession;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case vdcomCreateInstance_eo39:
        pSession = p->dbgMsgParm.v.CoCreateP.ikernel_sink;
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pLCD->m_sink_parms.sink_addr;
        len = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind) + 
          sizeof(tsp_dcom_co_create_instance_parms);
        memcpy ( pLCD->m_DbprocParms, p, len );
        p = pLCD->m_DbprocParms;
        eo38VDcomCreateInstance( &pLCD->m_DbprocParms->dbgMsgParm.v.CoCreateP );
        memcpy ( pLCD->m_DbprocParms, p, len );
        p->dbgMsgParm.v.CoCreateP.ikernel_sink = pSession;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case vdcomTransEnd_eo39:
        len = p->dbghdr.hdbgBufLen;
        p->dbgMsgParm.v.DispP.param_stack = (tsp_moveobj_ptr)((char*)pLCD->m_DbprocParms + 
          (long)p->dbgMsgParm.v.DispP.param_stack);
        lpstack = (teo39_Transend*)p->dbgMsgParm.v.DispP.param_stack;
        memcpy ( pLCD->m_DbprocParms, p, len );
        lpstack->lpbuf    = (teo39_TransendBuf *)((char*)pLCD->m_DbprocParms + (long)lpstack->lpbuf);
        paramStackLen     = lpstack->buflen;
        lpstack->lpbuflen = &paramStackLen;
        p = pLCD->m_DbprocParms;
        eo38VDcomTransEnd( &p->dbgMsgParm.v.DispP );
        lpstack->buflen = paramStackLen;
        len = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind)  + 
          sizeof(tsp_dcom_dispatch_parms);
        ptr_param = (unsigned char*) pLCD->m_DbprocParms;
        memcpy (ptr_param, p, len);
        ptr_param+= len;
        memcpy (ptr_param, &paramStackLen, sizeof(paramStackLen));
        len      += sizeof(paramStackLen);
        ptr_param+= sizeof(paramStackLen);
        memcpy (ptr_param, lpstack->lpbuf, paramStackLen);
        p->dbghdr.hdbgBufLen  = len + paramStackLen;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case vdcomReleaseAll_os39:    /* PTS 1104668 FF 17-Nov-99 */
        eo38VDcomReleaseAll(pLCD->m_sink_parms.sink_addr);
        p->dbghdr.hdbgBufLen  = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind)  + 
          sizeof(teo39_vdcomReleaseAll_rply);
        p->dbgMsgParm.v.ReleaseAll_rplyP.hr = 0;
        pLCD->m_DbgBuf2Length = 0;
        break;
      case vdcomDbproc_eo39:
        memcpy( &pSession, &p->dbgMsgParm.v.DispP.session_context, sizeof(pSession));
        memcpy( &p->dbgMsgParm.v.DispP.session_context, &pLCD->m_sink_parms.sink_addr, sizeof(pSession));
        len = sizeof(p->dbghdr) + 
          sizeof(p->dbgMsgParm.pdbgKind) + 
          sizeof(tsp_dcom_dispatch_parms);
        outlen = len;
        memcpy ( pLCD->m_DbprocParms, p, len );
        ptr_tstack = (teo39_TStack*)((unsigned long)p + 
          (unsigned long) p->dbgMsgParm.v.DispP.param_stack);
        param_cnt = p->dbgMsgParm.v.DispP.param_stack_len / sizeof(teo39_TStack);
        ptr_paramStack   = (teo39_TStack*) &pLCD->m_DbprocParmsStack[0];
        paramStackLen    = 0;
        ptr_param        = (unsigned char*)pLCD->m_DbprocParms;
        ptr_param        = ptr_param + len;
        pLCD->m_DbprocParms->dbgMsgParm.v.DispP.param_stack = 
          (tsp_moveobj_ptr) ptr_paramStack;
        ptr_inonly_param = pLCD->m_DbprocInOnlyParms;
        for ( i=1; i <= param_cnt; i++, ptr_tstack++ )
        {
          if ( ptr_tstack->is_ptr )
          {
            ptr_inbuf = (unsigned char*)p;
            ptr_inbuf = ptr_inbuf + (long)ptr_tstack->value.ptr;
            if ( ptr_tstack->inout_param == in_eeo39 )
            {
              memcpy( ptr_inonly_param, ptr_inbuf, ptr_tstack->length );
              ptr_paramStack->value.ptr = ptr_inonly_param;
              ptr_inonly_param = ptr_inonly_param + ptr_tstack->length;
            }
            else
            {
              if ( ptr_tstack->inout_param == inout_eeo39 )
                memcpy( ptr_param, ptr_inbuf, ptr_tstack->length );
              ptr_paramStack->value.ptr = ptr_param;
              ptr_param = ptr_param + ptr_tstack->length;
              outlen = outlen + ptr_tstack->length;
            }
            ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + sizeof(void*));
            paramStackLen  = paramStackLen + 4;
          }
          else
          {
            switch ( ptr_tstack->vt ) 
            {
            case csp1_vt_i1:
            case csp1_vt_ui1:
            case csp1_vt_bool:
            case csp1_vt_lc_int1:             
            case csp1_vt_lc_uint1:             
            case csp1_vt_lc_bool:
            case csp1_vt_lc_char:
            case csp1_vt_lc_byte:
              ptr_paramStack->value.i1 = ptr_tstack->value.i1;
              ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + 4);
              paramStackLen  = paramStackLen + 4;
              break;
            case csp1_vt_i2:
            case csp1_vt_ui2:
            case csp1_vt_lc_wchar:
              ptr_paramStack->value.i2 = ptr_tstack->value.i2;
              ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + 4);
              paramStackLen  = paramStackLen + 4;
              break;
            case csp1_vt_i4:
            case csp1_vt_ui4:
            case csp1_vt_int:
            case csp1_vt_uint:
              ptr_paramStack->value.i4 = ptr_tstack->value.i4;
              ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + 4);
              paramStackLen  = paramStackLen + 4;
              break;
            case csp1_vt_r4:
              ptr_paramStack->value.r4 = ptr_tstack->value.r4;
              ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + 4);
              paramStackLen  = paramStackLen + 4;
              break;           /* PTS 1104702 */
            case csp1_vt_r8:
            case csp1_vt_i8:
            case csp1_vt_ui8:
              ptr_paramStack->value.r8 = ptr_tstack->value.r8;
              ptr_paramStack = (teo39_TStack*)((char*)ptr_paramStack + 8);
              paramStackLen  = paramStackLen + 8;
              break;
            default:
              break;
            }
          }
        }
        p = pLCD->m_DbprocParms;
        p->dbgMsgParm.v.DispP.param_stack_len = paramStackLen;
        eo38VDcomDBProc( &p->dbgMsgParm.v.DispP );
        memcpy( &p->dbgMsgParm.v.DispP.session_context, &pSession, sizeof(pSession));
        p->dbghdr.hdbgBufLen  = outlen;
        pLCD->m_DbgBuf2Length = 0;
        break;
      default:
        pLCD->m_DbgBuf2Length = 0;
        break;
        }
        p->dbghdr.hdbgMsgKind = vdcomReply_eo39;
        break;
      case WAIT_OBJECT_0 + 1:         // StopThreadEvent
        bContinue = false ;
        break;
      case WAIT_TIMEOUT:
        break;
      default:
        break;
        }
        pLCD->m_buffer_ptr = (unsigned char*) p;
        SetEvent(pLCD->m_hCoReplyEvent) ;
    }
    eo38ReleaseInstance(&ReleaseParms);
    // PTS 1104668 eo38VDcomReleaseAll();
    CoUninitialize();
    SetEvent(pLCD->m_hDBProcTermEvent) ;
    return S_OK;
};

/*===========================================================================*
 *  LOCAL FUNCTIONS (CODE)                                                   *
 *===========================================================================*/



/*===========================================================================*
 *  END OF CODE                                                              *
 *===========================================================================*/