/****************************************************************************

  module      : gen13.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: sqluser_functions
  description : Sqluser Functions

  last changed: 1999-02-08  17:11
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN13_H
#define GEN13_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "vsp004.h"
#include "veo004c.h"
#include "gen00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC LONG sql13u_remove_xuser_entries ( tsp_errtext errtext );

externC int sql13c_get_serverdb ( char **serverdb );

externC int sql13c_get_dblang ( char **dblang );

externC teo00_Bool sql13c_only_blanks ( char * str );

externC LONG sql13u_get_all_entries ( char        **pcDataBuffer,
                                      ULONG        *lDataLen,
								  PREL611_XUSER_PAGE_UNION *pRel611XUserPages,
                                      tsp_errtext   errtext );

externC LONG sql13u_write_xuser_entries ( char              *XuserData,
                                          PXUSER_INFO_PAGE  pXUserInfoPage,
                                          tsp_errtext       errtext );

#endif  /* GEN13_H */

