/****************************************************************************

  module      : gen35.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: KERNEL LZU UNIX DCOM Threads
  description : Threads for serializing DCOM requests into seperated worker
                threads

  last changed: 1998-10-09  17:27
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN35_H
#define GEN35_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC void en35_VDCOMTransfer ( void *pTransportBuffer,
                  				  bool *pOk,
                  				  tsp00_ErrText *pErrtext );

externC bool en35_RemoveDCOMi ( void  );

externC void *en35_DCOM0 ( void *arg  );

#endif /* GEN35_H */
