/****************************************************************************

  module      : gen88.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: user_kernel_process
  description : USER KERNEL Process


  last changed: 1999-09-21  9:46
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN88_H
#define GEN88_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"
#include "gen50.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

#if defined(HP9)
externC int  e88_init_funcptr ( char *progname );
#endif

#if defined(PA20W)
externC void e71_init_task (ten50_UContext *);
#endif

externC void *en88_ukt ( void *arg );

externC void en88_CallA91Main ( void );

externC void e88_bindcpu ( ten50_UKT_Control * kp_to_bind );

externC void e88_task_exit ( void );

externC int  e88_init_dyn_task_stack ( struct TASK_TYPE * tcb );

#if !defined(USE_UCONTEXT) && (defined(I386) || defined(ALPHA))
externC void e88_stack_overflow ( ten50_UContext * cont );
#endif

#endif  /* GEN88_H */
