/****************************************************************************

  module      : hen54.h
  
  -------------------------------------------------------------------------
	
  responsible : JoergM
	  
  special area: disk_io
		
  description : Disk I/O
		  
  last changed: 1998-09-01  13:53
  see also    : example.html ...
			
  -------------------------------------------------------------------------
			  
  copyright:    Copyright by SAP AG, 1998
				


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEN54_H
#define HEN54_H

/*===========================================================================*
*  INCLUDES                                                                 *
*===========================================================================*/

#include "gsp00.h"

#include "vsp002.h"

#include "gen00.h"

/*===========================================================================*
*  FUNCTION PROTOTYPES                                                      *
*===========================================================================*/
externC void    vcurrdevsize ( tsp00_Int4     devno,
                            tsp00_Int4    *devcapacity,
                            tsp00_ErrText  errtext,
                            tsp00_Bool     *ok);

externC void    vdevsize ( tsp00_Int4          type_spec_devno,
                        tsp2_dev_type     devtype,
                        tsp00_Int4         *devcapacity,
                        tsp00_ErrText       errtext,
                        tsp00_Bool          *ok);

externC void    vattach ( tsp00_Int4           type_spec_devno,
                        tsp2_dev_type      devtype,
                        tsp00_Int4          *devno,
                        PROCESS_ID         pid,      /* Unused */
                        tsp00_ErrText        errtext,
                        tsp00_Bool           *ok);

externC void    vdetach ( tsp00_Int4        devno,
                         PROCESS_ID      pid);   /* Unused */

externC void    vmark_bad_dev ( tsp00_Int4        devno,
                                tsp_page_no     devpno );

externC tsp00_Int4 vget_data_io_cnt ();

externC void    vblockio (
                        tsp00_Int4        devno,
                        tsp_page_no     devpno,
                        tsp2_io_op_code  op_code,
                        BUFFERADDRESS   bufadr,
                        tsp00_Int2        buf_count,
                        PROCESS_ID      pid, /* unused */
                        tsp00_ErrText     errtext,
                        tsp00_Bool        *ok);
 
externC void               v2info (
                        tsp00_Int4        devno1,
                        tsp00_Int4        devno2,
                        tsp00_ErrText     errtext,
                        tsp2_v2_return  *rtc);

externC void    v2blckio ( tsp00_Int4        devno1,
						  tsp00_Int4        devno2,
						  tsp00_PageNo      devpno,
						  tsp2_io_op_code   op_code,
						  BUFFERADDRESS     bufadr,
						  tsp00_Int2        buf_count,
						  PROCESS_ID        pid,
						  tsp2_v2_devno    *read_dev,
						  tsp2_v2_devno    *error_dev,
						  tsp00_ErrText     errtext1,
						  tsp00_ErrText     errtext2,
						  tsp00_Bool       *ok);
 
externC void    vasynopen ( tsp00_VFilename hostfile,
						   tsp00_Bool      is_devspace,
						   tsp00_Bool      for_writing,
						   tsp00_VfType    filetype,
						   tsp00_Int4      block_size,
						   tsp00_Int4     *max_block_cnt,
						   tsp00_Int4     *hostfileno,
						   tsp00_VaReturn *returncode,
						   tsp00_ErrText   errtext);

externC void    vasynclose ( tsp00_Int4      hostfileno ,
							tsp00_Bool      rewind,
							tsp00_Bool      nxt_in_autoloader,
							tsp00_VaReturn *nxt_tape_available,
							tsp00_VaReturn *returncode ,
							tsp00_ErrText   errtext );

externC void    vasynclose_old ( tsp00_Int4       hostfileno,
								tsp00_Bool       nxt_in_autoloader,
								tsp00_VaReturn  *nxt_tape_available,
								tsp00_VaReturn  *returncode,
								tsp00_ErrText    errtext);
								
externC void vasynio ( tsp00_Int4          hostfileno,
					  tsp00_Int4          io_id,
					  tsp00_Int4          file_pos,
					  tsp00_Int4          io_block_cnt,
					  tsp00_Maxiobufaddr  io_block_ptr,
					  tsp00_VaReturn     *returncode,
					  tsp00_ErrText       errtext);

externC void vasynwait ( tsp00_Int4       hostfileno,
                        tsp00_Int4      *io_id,
                        tsp00_Int4      *io_block_cnt,
                        tsp00_VaReturn  *returncode,
                        tsp00_ErrText    errtext);
						
externC void vasyninit_tape ( tsp00_Int4      hostfileno,
						tsp00_Bool      destructive,
						tsp00_VfType   *filetype,
						tsp00_VaReturn *returncode,
						tsp00_ErrText   errtext);

externC void vdump_rte(void);

#endif  /* HEN54_H */
