/****************************************************************************

  module      : hen57.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: Storage Management
  description : Kernel allocation and cache routines
				vnewbuf, vallocat, vmnewbuf, vmfreebuf, vmalloc, vmfree


  last changed: 1998-09-01  16:07
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef HEN57_H
#define HEN57_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC void vnewbuf ( tsp_int4        count ,
					   tsp_int4       *available ,
					   tsp00_PageAddr *bufptr ,
					   tsp00_Bool     *ok );

externC void valloc_datacache ( tsp_int4       count ,
								tsp_int4      *available ,
								BUFFERADDRESS *bufptr ,
								tsp00_Bool    *ok );

externC void valloc_convcache ( tsp_int4       count ,
								tsp_int4      *available ,
								BUFFERADDRESS *bufptr ,
								tsp00_Bool    *ok );

externC void vallocat ( tsp_int4    length ,
						UCHAR     **objptr ,
						tsp00_Bool *ok );

externC void vmnewbuf ( tsp_int4        count ,  /* length in pagesizes */
						tsp00_BufAddr * bufptr ,
						tsp00_Bool    * ok );

externC void vmfreebuf ( BUFFERADDRESS bufptr );

externC void vmalloc ( tsp_int4    length ,
					   UCHAR     **objptr ,
					   tsp00_Bool *ok );

externC void vmrealloc ( tsp_int4 length ,        /* bytes requested */
						 UCHAR  **objptr ,             /* buffer address */
						 tsp00_Bool *ok );

externC void vmfree ( UCHAR *objptr );

#endif  /* HEN57_H */
