/* @lastChanged: "1998-04-27  18:28"
 * @filename:    geo002.h
 * @purpose:     "XXX YYY XXX"
 * @release:     7.1.1.1
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef GEO002_H
#define GEO002_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "vsp002.h"
#include "geo00_0.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#define DEVSPACE_UNUSED  -1

#define NUM_DEVSP_TYPES 8

/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/

#if defined(_WIN32)
# define XPARAM(_param_elem) (((RTE_XPARAM_REC *)(kgs.XParam))->_param_elem)
#else /* UNIX */
# define XPARAM(_param_elem) (((RTE_XPARAM_REC *)(kgs->XParam))->_param_elem)
#endif

/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

/* --- RTE_XPARAM_REC ------------------------------------------------------ */

typedef struct  dev_descr
  {
    tsp2_devnamec             szDevspaceName;
    tsp00_Int                 lDevspaceSize;
    tsp00_Int                 lDevspaceType;
  } DEV_DESCR;

typedef struct  devspaces_descr
  {
    tsp00_Uint                ulNumDevs;
    DEV_DESCR                 *Devspaces;
  } DEVSPACES_DESCR;

typedef struct  rte_xparam_record
  {
  tsp00_VFilenamec            szRunDirectory;
  tsp00_CryptPw               crypControlPassw;
  tsp00_KnlIdentifierc        szControlUser;
  tsp00_Uint                  ulDBPageSize;
  tsp00_Int                   lNoOfBackupDevs;
  teo00_Bool                  fLogBackToPipe;          /* PTS 1108249 */
  tsp00_Int                   lMaxSysDevspaces;
  tsp00_Int                   lMaxArchiveLogs;
  tsp00_Int                   lMaxDataDevspaces;
  tsp00_Int                   lLogMode;
  tsp00_Int                   lLogSegmentSize;
  tsp00_Int                   lSessionTimeout;
  tsp00_Int                   lLockTimeout;
  tsp00_Int                   lRequestTimeout;
  tsp00_Int                   lNetTimeout;
  tsp00_Int                   lRestartTime;
  tsp00_C18c                  szDefaultCode;
  tsp00_C18c                  szDateTimeFormat;
  tsp00_Int                   lMaxTrans;
  tsp00_Int                   lSequenceCache;
  tsp00_Int                   lDataCachePages;
  tsp00_Int                   lCatalogCachePages;
  tsp00_Int                   lDistribDescCache;
  tsp00_Int                   lMaxDataPages;
  tsp00_Int                   lFbmCachePages;
  tsp00_Bool                  fUseThreadForTask;         /* PTS 1108525 */
  tsp00_Bool                  fUseProcessScope;          /* PTS 1108911 */
  tsp00_Uint                  ulMaxUsUtStack;
  tsp00_Int                   lMaxLocks;
  tsp00_Uint                  ulDeadlockDetection;
  tsp00_Int                   ulLockSupplyBlock;
  tsp00_Int                   lServerCmdCache;
  tsp00_Int                   lMinServerDesc;
  tsp00_Int                   lMaxServerDB;
  tsp00_Int                   lLogQueuePages;
  tsp00_Int                   lLogCachePages;
  tsp00_Int                   lConvCachePages;
  tsp00_Int                   lUsmCachePages;
  tsp00_Int                   lBackUpBlockCount;
  tsp00_Int                   lMaxDevspaces;
  tsp00_Int                   lJoinPrefetchPercent;
  tsp00_Int                   lJoinSearchLevel;
  tsp00_Int                   lJoinMaxTabLevel4;
  tsp00_Int                   lJoinMaxTabLevel9;
  tsp00_Int                   lDistinctOverhead;
  tsp00_Int                   lOrderbyFactor;
  tsp00_Int                   lBuildResultPercent;
  tsp00_Int                   lFetchResultPercent;
  tsp00_Int                   lMaxMerge;
  tsp00_Int                   lKeyInvRatePercent;
  tsp00_Int                   lDwCopyBoundary;
  tsp00_Int                   lDwIOAreaSize;
  tsp00_Int                   lDwIOAreaFlush;
  tsp00_Int                   lDwLRUTailFlush;
  tsp00_Int                   lFbmBalance;
  tsp00_Int                   lFbmCompression;
  tsp00_Int                   lFbmLowIORate;
  tsp00_Int                   lLogStartCopy;
  tsp00_Int                   lLogCopyDistance;
  tsp00_Int                   lReservedRedoSize;



  tsp00_C40c                  szKernelVersion;

  tsp00_Int                   lSharedDynData;
  tsp00_Int                   lSharedDynPool;

  tsp00_VFilenamec            szDiagFile;
  tsp00_Uint                  ulDiagSize;

  tsp00_VFilenamec            szEventFile;
  tsp00_Uint                  ulEventSize;
  tsp00_Uint                  ulMaxEvents;
  tsp00_Uint                  ulEventAliveCycle;

  tsp00_VFilenamec            szBackupHistFile;
  tsp00_VFilenamec            szBackupMedDefFile;

  tsp00_VFilenamec            szUtilityProtFile;
  tsp00_Uint                  ulUtilityProtSize;

  tsp00_VFilenamec            szDumpFilename;

  tsp2_devnamec               szTraceDevspace;
  tsp00_Int                   lTraceDevspaceSize;

  tsp00_Int                   lDeviPerDevspace;
  tsp00_Int                   lPrioDeviPerDevspace;
  tsp00_Int                   lDevQueue;

  tsp00_Int                   lRealtimePrio;
  tsp00_Uint                  ulMaxCPU;
  tsp00_Uint                  ulRegionCollisionLoop;
  tsp00_Uint                  ulNoOfRegions;
  char                        **TaskClusterArray;

  tsp00_Uint                  ulRegLockSlice;
  tsp00_Int                   lPrioBaseU2U;
  tsp00_Int                   lPrioBaseRAV;
  tsp00_Int                   lPrioBaseIOC;
  tsp00_Int                   lPrioBaseCOM;
  tsp00_Int                   lPrioBaseREX;
  tsp00_Int                   lPrioFactor;
  tsp00_Int                   lDelayLW;

  teo00_Bool                  fServerDBForSAP;
  teo00_Bool                  fDefaultLRU;
  teo00_Bool                  fDelayCommit;
  teo00_Bool                  fDbSockets;

  teo00_Bool                  fAllowSingleIO;
  teo00_Bool                  fExclQueue;
  teo00_Bool                  fBegExclQueWhenPrio;
  teo00_Bool                  fBegExclDirtyRead;

  teo00_Bool                  fEndExclBusyWait;
  teo00_Bool                  fDynDispQueSrch;
  teo00_Bool                  fSubtree;
  teo00_Bool                  fUnicode;

  teo00_Bool                  fMirrData;
  teo00_Bool                  fSvpFstConvFlush;
  tsp00_Bool                  fUseMemEnhancement;
  tsp00_Uint                  lMemEnhancementLimit;
  teo00_Bool                  fUseAsyncIO;

  teo00_Bool                  fFormatDevspace;
  teo00_Bool                  fEventPrio;
  teo00_Bool                  fAKDumpAllowed;
  teo00_Bool                  fStackStack;

  tsp00_Uint                  ulMultIOBlockCount;

  tsp00_Uint                  ulMaxDataWriter;
  tsp00_Uint                  ulMaxEventTasks;
  tsp00_Uint                  ulMaxBackupTasks;
  tsp00_Uint                  ulMaxGarbageCollector;
  tsp00_Uint                  ulMaxObjectLogWriter;
  tsp00_Uint                  ulMaxArchiveLogWriter;
  tsp00_Uint                  ulMaxUser;
  tsp00_Uint                  ulMaxServer;

  tsp00_Uint                  ulDwIOBufSize;
  tsp00_Uint                  ulDispLoopsBefSemop;
  tsp00_Uint                  ulNumDataCacheReg;
  tsp00_Uint                  ulNumTreeReg;
  tsp00_Uint                  ulNumTransReg;
  tsp00_Uint                  ulNumTabReg;
  tsp00_Uint                  ulNumRowReg;
  tsp00_Uint                  ulNumOMSReg;
  tsp00_Uint                  ulPacketSize;
  tsp00_Uint                  ulMinReplySize;
  tsp00_Uint                  ulPnoPoolSize;
  tsp00_Uint                  ulMaxAutoBackupDevs;
  tsp00_Uint                  ulMBDataSize;
  tsp00_Uint                  ulMBQualSize;
  tsp00_Uint                  ulMBStackSize;
  tsp00_Uint                  ulKBWorkStSize;
  tsp00_Uint                  ulKBWorkBufSize;
  tsp00_Uint                  ulCatalogCacheSize;
  tsp00_Uint                  ulMultiByteTotalSize;
  tsp00_Uint                  ulXparamChanged;
  tsp00_KnlIdentifierc        szMultiByteSet_1;
  tsp00_KnlIdentifierc        szMultiByteSet_2;
  tsp00_KnlIdentifierc        szMultiByteSet_3;
  tsp00_KnlIdentifierc        szMultiByteSet_4;
  tsp00_KnlIdentifierc        szMultiByteSet_5;
  DEVSPACES_DESCR             DevspDescr   [NUM_DEVSP_TYPES];
  tsp00_VFilenamec            szRTEDumpFilename;
  tsp00_Uint                  ulObjLogSize;
  tsp00_Uint                  ulObjLogIOQueuePages;
  tsp00_Uint                  ulObjLogRollbackCache;
  tsp00_Uint                  ulObjLogSegmentSize;
  tsp00_Uint                  ulReadAheadBlobsGT;
  tsp00_Int                   lIndexfileListSize;
  tsp00_Uint                  ulMaxMessageFiles;
  tsp00_Uint                  ulOMSHeapLimit;       /* CR 1105220 */
  tsp00_Uint                  uCrashHistoryNum;
  tsp00_VFilenamec            szCrashHistoryPath;
  tsp00_Uint                  uCrashSem;
/***************************************************************/
#if defined(_WIN32)
/***************************************************************/
  tsp00_Uint                  ulRTEAllocPoolSize;
  tsp00_Uint                  ulKernelAllocPoolSize;
  teo00_Bool                  fDynamicServerTasks;
  teo00_Bool                  fAllowCompressedDevsp;
  teo00_Bool                  fAutoRestartShutdown;
  teo00_Bool                  fProfileDCOMObject;   /* CR 1000241 */
  teo00_Bool                  fUseFibers;
/***************************************************************/
#else
/***************************************************************/
  tsp00_VFilenamec            szOpMsg1;
  tsp00_VFilenamec            szOpMsg2;
  teo00_Bool                  fDynTaskStack;
  teo00_Bool                  fUseSharedMMU;	/* CR 1000130 */
  tsp00_Int                   lShmChunk;
  tsp00_Int                   lShmKernel;
  tsp00_Int                   useOpenDirect;    /* CR 1118800 */
/***************************************************************/
#endif
/***************************************************************/
/* PTS 1105389 */
  tsp00_C8c                   szInstanceType;

/* PTS 1108975 */
/* PTS 1109363 */
  tsp00_Int                   tracePagesTI;
  tsp00_Int                   tracePagesGC;
  tsp00_Int                   tracePagesAL;
  tsp00_Int                   tracePagesDW;
  tsp00_Int                   tracePagesUS;
  tsp00_Int                   tracePagesUT;
  tsp00_Int                   tracePagesSV;
  tsp00_Int                   tracePagesEV;
  tsp00_Int                   tracePagesTW;
  tsp00_Int                   tracePagesCS;
  tsp00_Int                   tracePagesBUP;

    /* PTS 1113403 */
  tsp00_Bool                  suppressCore;

  /* PTS 1116153 */
  tsp00_NodeIdc               szOfficialNode;

} RTE_XPARAM_REC;

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

/*================================================*/

/* --- VEO11UC - ( EXTRACT XPARAMFILE FROM SAVE ) ------------------------- */

void    sqlextract_xparamfile(  tsp_vfilename   SaveFile ,
                                tsp_int2        BufCnt,
                                tsp_dbname      XparamName,
                                tsp_vf_return  *Error,
                                tsp_errtext     acErrorText);

/* --- VEO79C -------------------------------------------------------------- */

void   sql79k_deb_taskcluster_array( RTE_XPARAM_REC            *XParam);

void   sql79k_create_taskcluster(   RTE_XPARAM_REC  *XParam,
                                    char            **TaskCluster );

void   sql79k_free_taskcluster  (   RTE_XPARAM_REC  *XParam,
                                    char            *TaskCluster );





#endif  /* GEO002_H */

