/* @lastChanged: "1998-04-21  18:46"
 * @filename:    geo002xp.h
 * @purpose:     "XPARAM identifier strings"
 * @release:     7.1.1.1
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef GEO002XP_H
#define GEO002XP_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

/* names for param file */
#define         PAN_INSTANCE_TYPE             "INSTANCE_TYPE"

#define         PAN_PARAM_KERNELVERSION       "KERNELVERSION"
#define         PAN_SERVERDB                  "SERVERDB"
#define         PAN_SYSDEV                    "SYSDEVSPACE"
#define         PAN_MIRR_SYSDEV               "MIRR_SYSDEVSPACE"
#define         PAN_TARNSACTION_LOG           "TRANSACTION_LOG"
#define         PAN_TARNSACTION_LOG_SIZE      "TRANS_LOG_SIZE"
#define         PAN_ARCHIVE_LOG               "ARCHIVE_LOG"
#define         PAN_MIRR_ARCHIVE_LOG          "MIRR_ARCHIVE_LOG"
#define         PAN_CONTROLID                 "CONTROLUSERID"
#define         PAN_CONTROLPW                 "CONTROLPASSWORD"
#define         PAN_MAXBACKUPDEVS             "MAXBACKUPDEVS"
#define         PAN_ALLOW_LBACK_TO_PIPE       "LOG_BACKUP_TO_PIPE"
#define		      MAX_BACKUP_DEVS		            16


#define         PAN_MAXTRANS                  "_MAXTRANS"
#define         PAN_DATA_CACHE_PAGS           "DATA_CACHE"
#define         PAN_SEQUENCE_CACHE            "SEQUENCE_CACHE"
#define         PAN_CATALOG_CACHE             "CAT_CACHE_SUPPLY"
#define         PAN_SERVER_DESC_CACHE         "_SERVER_DESC_CACHE"
#define         PAN_SERVER_CMD_CACHE          "_SERVER_CMD_CACHE"
#define         PAN_USE_THRD_FOR_TSK          "_USE_THRD_FOR_TSK"  /* PTS 1108525 */
#define         PAN_USE_PROC_SCOPE            "_USE_PROC_SCOPE"    /* PTS 1108911 */
#define         PAN_MAXACTIVE                 "MAXUSERTASKS"
#define         PAN_MAXSERVERDB               "_MAXSERVERDB"
#define         PAN_MIN_SERVER_DESC           "_MIN_SERVER_DESC"
#define         PAN_MAXSERVER                 "MAXSERVERTASKS"
#define         PAN_LOG_IO_QUEUE              "LOG_IO_QUEUE"
#define         PAN_ROLLBACK_CACHE            "ROLLBACK_CACHE"
#define         PAN_MAXLOCKS                  "MAXLOCKS"
#define         PAN_DEADLOCK_DETECTION        "DEADLOCK_DETECTION"
#define         PAN_LOCK_SUPPLY_BLOCK         "_LOCK_SUPPLY_BLOCK"
#define         PAN_FBM_CACHE_PAGES           "_FBM_CACHE"
#define         PAN_CONV_CACHE_PAGES          "CONVERTER_CACHE"
#define         PAN_USM_CACHE_PAGES           "_USM_CACHE"
#define         PAN_BACKUP_BLOCK_CNT          "BACKUP_BLOCK_CNT"
#define         PAN_DEFAULT_LRU               "LRU_FOR_SCAN"

#define         PAN_JOIN_SEARCH_LEVEL         "JOIN_SEARCH_LEVEL"
#define         PAN_JOIN_MAXTAB_LEVEL4        "JOIN_MAXTAB_LEVEL4"
#define         PAN_JOIN_MAXTAB_LEVEL9        "JOIN_MAXTAB_LEVEL9"

#define         PAN_OPTIM_OR_DISTINCT         "OPTIM_OR_DISTINCT"
#define         PAN_OPTIM_ORDERBY_IDX         "OPTIM_ORDERBY_IDX"
#define         PAN_OPTIM_BUILD_RESLT         "OPTIM_BUILD_RESLT"
#define         PAN_OPTIM_FETCH_RESLT         "OPTIM_FETCH_RESLT"
#define         PAN_OPTIM_JOIN_FETCH          "OPTIM_JOIN_FETCH"
#define         PAN_OPTIM_MAX_MERGE           "OPTIM_MAX_MERGE"
#define         PAN_OPTIM_KEY_INV_RATE        "OPTIM_KEY_INV_RATE"

#define         PAN_DYNDATA                   "_SHAREDDYNDATA"
#define         PAN_DYNPOOL                   "_SHAREDDYNPOOL"
#define         PAN_PNOPOOLSIZE               "_PNO_SUPPLY_SIZE"

#define         PAN_RUNDIR                    "RUNDIRECTORY"
#define         PAN_MAXDEVSPACES              "_MAXDEVSPACES"

#define         PAN_TASKCLUSTER_N             "_TASKCLUSTER_"
#define         PAN_TASKCLUSTER_N_LN          13

#define         PAN_MAXSYSDEVSPACES           "_MAXSYSDEVSPACES"
#define         PAN_SYS_N                     "SYSDEV_"
#define         PAN_SYS_N_LN                  7
#define         PAN_SYS_N_SIZE                "SYS_SIZE_"
#define         PAN_SYS_N_SIZE_LN             8

#define         PAN_M_SYS_N                   "M_SYSDEV_"
#define         PAN_M_SYS_N_LN                9

#define         PAN_MAXARCHIVELOGS            "MAXARCHIVELOGS"
#define         PAN_ARCHIVE_LOG_N             "ARCHIVE_LOG_"
#define         PAN_ARCHIVE_LOG_N_LN          12
#define         PAN_ARCHIVE_LOG_N_SIZE        "ARCHIVE_SIZE_"
#define         PAN_ARCHIVE_LOG_N_SIZE_LN     13

#define         PAN_M_ARCHIVE_LOG_N           "M_ARCHIVE_LOG_"
#define         PAN_M_ARCHIVE_LOG_N_LN        14

#define         PAN_LOG_MODE                  "LOG_MODE"
#define         PAN_LOG_SEGMENT_SIZE          "LOG_SEGMENT_SIZE"
#define         PAN_DEFAULT_CODE              "DEFAULT_CODE"
#define         PAN_DATE_TIME_FORMAT          "DATE_TIME_FORMAT"
#define         PAN_SESSION_TIMEOUT           "SESSION_TIMEOUT"
#define         PAN_LOCK_TIMEOUT              "LOCK_TIMEOUT"
#define         PAN_REQUEST_TIMEOUT           "REQUEST_TIMEOUT"
#define         PAN_NET_TIMEOUT               "_NET_MINTIMEOUT"
#define         PAN_RESTART_TIME              "_RESTART_TIME"

#define         PAN_MAXDATADEVSPACES          "MAXDATADEVSPACES"
#define         PAN_DATADEV_N                 "DATADEV_"
#define         PAN_DATADEV_N_LN              8
#define         PAN_DATADEV_N_SIZE            "DATA_SIZE_"
#define         PAN_DATADEV_N_SIZE_LN         10

#define         PAN_MIRR_DATA                 "_MIRRORED_DATA"
#define         PAN_M_DATADEV_N               "M_DATADEV_"
#define         PAN_M_DATADEV_N_LN            10

#define         PAN_USE_ASYNC_IO              "_USE_ASYNC_IO"
#define         PAN_MAXIOTHREADS              "_IOPROCS_PER_DEV"
#define         PAN_IOTHREADS_FOR_PRIO        "_IOPROCS_FOR_PRIO"
#define         PAN_DEV_QUEUE                 "_IOPROCS_SWITCH"
#define         PAN_USE_IOTHREAD_ONLY         "_USE_IOPROCS_ONLY"

#define         PAN_MAXDATAPAGES              "MAXDATAPAGES"
#define         PAN_MAXCPU                    "MAXCPU"
#define         PAN_PRIO_BASE_U2U             "_PRIO_BASE_U2U"
#define         PAN_PRIO_BASE_IOC             "_PRIO_BASE_IOC"
#define         PAN_PRIO_BASE_RAV             "_PRIO_BASE_RAV"
#define         PAN_PRIO_BASE_COM             "_PRIO_BASE_COM"
#define         PAN_PRIO_BASE_REX             "_PRIO_BASE_REX"
#define         PAN_PRIO_FACTOR               "_PRIO_FACTOR"
#define         PAN_DELAY_LW                  "_DELAY_LOGWRITER"
#define         PAN_DELAY_COMMIT              "_DELAY_COMMIT"
#define         PAN_SUBTREE                   "SUBTREE"
#define         PAN_MAXRGN_REQUEST            "MAXRGN_REQUEST"
#define         PAN_MP_RGN_LOOP               "MP_RGN_LOOP"
#define         PAN_MP_RGN_QUEUE              "_MP_RGN_QUEUE"
#define         PAN_MP_RGN_BUSY_WAIT          "_MP_RGN_BUSY_WAIT"
#define         PAN_MP_RGN_PRIO               "_MP_RGN_PRIO"
#define         PAN_MP_RGN_DIRTY_READ         "_MP_RGN_DIRTY_READ"
#define         PAN_MP_DISP_PRIO              "_MP_DISP_PRIO"
#define         PAN_MP_DISP_LOOPS             "_MP_DISP_LOOPS"
#define         PAN_DATACACHE_REGIONS         "_DATA_CACHE_RGNS"
#define         PAN_TREE_REGIONS              "_TREE_RGNS"
#define         PAN_TRANS_REGIONS             "_TRANS_RGNS"
#define         PAN_TAB_REGIONS               "_TAB_RGNS"
#define         PAN_ROW_REGIONS               "_ROW_RGNS"
#define         PAN_OMS_REGIONS               "_OMS_RGNS"
#define         PAN_MAXUSERSTACK              "_MAXTASK_STACK"

#define         PAN_MAXDATAWRITER             "_MAXDATAWRITER"
#define         PAN_COPY_IO_BLOCK_CNT         "_COPY_IO_BLOCK_CNT"
#define         PAN_MULT_IO_BLOCK_CNT         "_MULT_IO_BLOCK_CNT"
#define         PAN_REALTIME_PRIO             "REALTIME_PRIO"

#define         PAN_UNICODE_CATALOG           "_UNICODE"
#define         PAN_MULTIBYTE_SET_1           "_MULTIBYTE_SET1"
#define         PAN_MULTIBYTE_SET_2           "_MULTIBYTE_SET2"
#define         PAN_MULTIBYTE_SET_3           "_MULTIBYTE_SET3"
#define         PAN_MULTIBYTE_SET_4           "_MULTIBYTE_SET4"
#define         PAN_MULTIBYTE_SET_5           "_MULTIBYTE_SET5"
#define         PAN_MULTIBYTE_CACHE           "_MULTIBYTE_CACHE"

#define         PAN_PACKET_SIZE               "_PACKET_SIZE"
#define         PAN_MIN_REPLY_SIZE            "_MINREPLY_SIZE"
#define         PAN_MAXAUTOBACKUPDEVS         "_MAXAUTOBACKUPDEVS"

#define         PAN_MB_DATA_SIZE              "_MBLOCK_DATA_SIZE"
#define         PAN_MB_QUAL_SIZE              "_MBLOCK_QUAL_SIZE"
#define         PAN_MB_STACK_SIZE             "_MBLOCK_STACK_SIZE"
#define         PAN_KB_WORK_ST_SIZE           "_WORKSTACK_SIZE"
#define         PAN_KB_WORKBUF_SIZE           "_WORKDATA_SIZE"
#define         PAN_CATALOG_CACHE_SIZE        "_CAT_CACHE_MINSIZE"

#define         PAN_GATEWAYTYPE               "GATEWAYTYPE"
#define         PAN_DW_COPY_BOUNDARY          "_DW_COPY_BOUNDARY"
#define         PAN_DW_IO_AREA_SIZE           "_DW_IO_AREA_SIZE"
#define         PAN_DW_IO_AREA_FLUSH          "_DW_IO_AREA_FLUSH"
#define         PAN_DW_LRU_TAIL_FLUSH         "_DW_LRU_TAIL_FLUSH"
#define         PAN_FBM_DEVSP_BALANCE         "_FBM_DEVSP_BALANCE"
#define         PAN_FBM_DEVSP_COMPR           "_FBM_DEVSP_COMPR"
#define         PAN_FBM_LOW_IO_RATE           "_FBM_LOW_IO_RATE"
#define         PAN_LOG_START_COPY            "_LOG_START_COPY"
#define         PAN_LOG_COPY_DISTANCE         "_LOG_COPY_DISTANCE"
#define         PAN_RESERVED_REDO_SIZE        "RESERVED_REDO_SIZE"
#define         PAN_BACKUP_HISTFILE           "_BACKUP_HISTFILE"
#define         PAN_BACKUP_MED_DEF            "_BACKUP_MED_DEF"
#define         PAN_KERNELDUMPFILE            "_KERNELDUMPFILE"
#define         PAN_KERNELTRACEFILE           "_KERNELTRACEFILE"
#define         PAN_KERNELTRACESIZE           "KERNELTRACESIZE"
#define         PAN_DIAGFILE                  "_KERNELDIAGFILE"
#define         PAN_DIAG_SIZE                 "KERNELDIAGSIZE"
#define         PAN_UTILITY_PROTFILE          "_UTILITY_PROTFILE"
#define         PAN_UTILITY_PROTSIZE          "UTILITY_PROTSIZE"
#define         PAN_SVP_1_CONV_FLUSH          "_SVP_1_CONV_FLUSH"
#define         PAN_RTEDUMPFILE               "_RTEDUMPFILE"
#define         PAN_FORMAT_DEVSPACE           "FORMAT_DEVSPACE"

#define         PAN_EVENTFILE                 "_EVENTFILE"
#define         PAN_EVENT_SIZE                "_EVENTSIZE"
#define         PAN_MAXEVENTTASKS             "_MAXEVENTTASKS"
#define         PAN_EVENTPRIO                 "_EVENTPRIO"
#define         PAN_MAXEVENTS                 "_MAX_EVENTS"
#define         PAN_XPARAM_CHANGED            XP_PARAM_CHANGED
#define         PAN_PARAM_VERSION_TIME        XP_PARAM_VERSION_TIME
#define         PAN_PAGE_SIZE                 "_PAGE_SIZE"

#define         PAN_OBJ_LOG_SIZE              "OBJ_LOG_SIZE"
#define         PAN_OBJ_LOG_SEGMENT_SIZE      "OBJ_LOG_SEG_SIZE"
#define         PAN_OBJ_LOG_IO_QUEUE          "OBJ_LOG_IO_QUEUE"
#define         PAN_OBJ_ROLLBACK_CACHE        "OBJ_ROLLBACK_CACHE"
#define         PAN_OMS_HEAP_LIMIT            "OMS_HEAP_LIMIT"

#define         PAN_MAXGARBAGE_COLLECTOR      "_MAXGARBAGE_COLL"
#define         PAN_MAX_BACKUP_TASKS          "_MAX_BACKUP_TASKS"
#define         PAN_READAHEAD_BLOBS           "_READAHEAD_BLOBS"
#define         PAN_SERVERDB_FOR_SAP          "_SERVERDB_FOR_SAP"
#define         PAN_EVENT_ALIVE_CYCLE         "_EVENT_ALIVE_CYCLE"

#define         PAN_INDEXFILE_LIST_SIZE       "_IDXFILE_LIST_SIZE"
#define         PAN_AK_DUMP_ALLOWED           "_AK_DUMP_ALLOWED"
#define         PAN_MAX_MESSAGE_FILES         "_MAX_MESSAGE_FILES"
#define         PAN_TASK_STACK_AREA           "_TASK_STACK_AREA"
#define         PAN_CRASH_HISTORY_NUM         "DIAG_HISTORY_NUM"
#define         PAN_CRASH_HISTORY_PATH        "DIAG_HISTORY_PATH"
#define         PAN_CRASH_SEM		          "_DIAG_SEM"
/***************************************************************/
#if defined(_WIN32) || defined(OS2)
/***************************************************************/

#define         PAN_KERNEL_ALLOC_POOL         "_KERNEL_ALLOC_POOL"
#define         PAN_RTE_ALLOC_POOL            "RTE_ALLOC_POOL"
#define         PAN_DYNAMIC_SERVER            "DYNAMIC_SERVER"
#define         PAN_ALLOW_COMPR_DEVSP         "ALLOW_COMPR_DEVSP"
#define         PAN_RESTART_SHUTDOWN          "RESTART_SHUTDOWN"
#define         PAN_DCOM_DEBUG                "DCOM_DEBUG"
#define         PAN_USE_MEM_ENHANCEMENT       "USE_MEM_ENHANCE"
#define         PAN_MEM_ENHANCEMENT_LIM       "MEM_ENHANCE_LIMIT"
#define         PAN_USE_FIBERS                "USE_FIBERS"
/***************************************************************/
#else
/***************************************************************/

#define         PAN_SHMCHUNK                  "_SHMCHUNK"
#define         PAN_SHMKERNEL                 "_SHMKERNEL"

#define         PAN_DYNAMIC_TASK_STACK        "_DYN_TASK_STACK"
#define         PAN_OPMSG1                    "OPMSG1"
#define         PAN_OPMSG2                    "OPMSG2"

/***************************************************************/
#endif

/* PTS 1108973 Trace Size for each task type in pages */
#define         PAN_TRACE_PAGES_TI            "TRACE_PAGES_TI"
#define         PAN_TRACE_PAGES_GC            "TRACE_PAGES_GC"
#define         PAN_TRACE_PAGES_AL            "TRACE_PAGES_AL"
#define         PAN_TRACE_PAGES_DW            "TRACE_PAGES_DW"
#define         PAN_TRACE_PAGES_US            "TRACE_PAGES_US"
#define         PAN_TRACE_PAGES_UT            "TRACE_PAGES_UT"
#define         PAN_TRACE_PAGES_SV            "TRACE_PAGES_SV"
#define         PAN_TRACE_PAGES_EV            "TRACE_PAGES_EV"
#define         PAN_TRACE_PAGES_TW            "TRACE_PAGES_TW"
#define         PAN_TRACE_PAGES_CS            "TRACE_PAGES_CS"
#define         PAN_TRACE_PAGES_BUP           "TRACE_PAGES_BUP"

/* PTS 1111787 */
#define         PAN_COMMENT                   "_COMMENT"

/* PTS 1113403 */
#define         PAN_SUPPRESS_CORE             "SUPPRESS_CORE"

/* PTS 1116153 */
#define         PAN_OFFICIAL_NODE             "OFFICIAL_NODE"

/* PTS 1118800 */
#define         PAN_USE_OPEN_DIRECT           "USE_OPEN_DIRECT"

/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/



#endif  /* GEO002XP_H */
