/* @lastChanged: "1998-04-27  15:47"
 * @filename:    geo00k.h
 * @purpose:     "general RTE KERNEL header file"
 * @release:     7.1.1.1
 * @see:         ""
 *
 * @copyright:   "Copyright by   SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef GEO00K_H
#define GEO00K_H

/*----------------------------------------------------------------------------*
 *  INCLUDES                                                                  *
 *----------------------------------------------------------------------------*/

#include "gsp00.h"
#if defined(_WIN32) /* &if $OS = WIN32 */
#include "gos00.h" /* nocheck */
#else               /* &else */
#include "gen00.h" /* nocheck */
#endif              /* &endif */
#include "veo00c.h"

/*----------------------------------------------------------------------------*
 *  DEFINES                                                                   *
 *----------------------------------------------------------------------------*/

/* --- Request types */
#define REQ_VATTACH_EO00K	                      1
#define REQ_VBLOCKIO_EO00K                        2
#define REQ_VDETACH_EO00K                         3
#define REQ_INITOK_EO00K                          4
#define REQ_VRESUME_EO00K                         5
#define REQ_VSIGNAL_EO00K                         6
#define REQ_VSLEEP_EO00K                          7
#define REQ_CONNECT_EO00K                         8
#define REQ_RELEASE_EO00K                         9
#define REQ_VRECEIVE_EO00K                        10
#define REQ_SHUTDOK_EO00K                         11
#define REQ_SENDER_JOB_FREE_EO00K                 12
#define REQ_VENDEXCL_EO00K                        13
#define REQ_RESCHEDULE_EO00K                      14
#define REQ_SHUTDOWN_RESUME_TW_EO00K              15
#define REQ_ASYNOPEN_EO00K                        16
#define REQ_ASYNCLOSE_EO00K                       17
#define REQ_ASYNIO_EO00K                          18
#define REQ_ASYNWAIT_EO00K                        19
#define REQ_VNSHUTDOWN_REPLY_EO00K                20
#define REQ_OUTGOING_CONNECT_EO00K                21
#define REQ_OUTGOING_CONNECT_REPLY_EO00K          22
#define REQ_OPEN_WAKEUP_SD_EO00K                  23
#define REQ_CONNECT_RC_EO00K                      24
#define REQ_RELEASE_RC_EO00K                      25
#define REQ_CLOSE_OUTGOING_EO00K                  26
#define REQ_CLOSE_OUTGOING_REPLY_EO00K            27
#define REQ_FINISH_SV_EO00K                       28
#define REQ_ASYNCNTL_EO00K                        29
#define REQ_OVERLAPPED_IO_FINISED_EO00K           30
#define REQ_MARK_BAD_DEVSPACE_EO00K               31
#define REQ_DCOM_CREATE_DCOMI_EO00K               32
#define REQ_DCOM_REMOVE_DCOMI_EO00K               33
#define REQ_DCOM_PARAMINFO_EO00K                  34
#define REQ_DCOM_CO_CREATE_INSTANCE_EO00K         35
#define REQ_DCOM_RELEASE_INSTANCE_EO00K           36
#define REQ_DCOM_CO_GET_CLASSOBJECT_EO00K         37
#define REQ_DCOM_TRANSFER_EO00K                   38
#define REQ_DCOM_RELASE_ALL_EO00K                 39
        
/* --- task types */
#define TT_TI_EO00K                   11
#define TT_TL_EO00K                   12
#define TT_AL_EO00K                   13
#define TT_TW_EO00K                   14
#define TT_DW_EO00K                   15
#define TT_SN_EO00K                   16
#define TT_RC_EO00K                   17
#define TT_UT_EO00K                   18
#define TT_CS_EO00K                   19

#define TT_EV_EO00K                   20
#define TT_GC_EO00K                   21
#define TT_BUP_EO00K                  22
#define TT_OL_EO00K                   23

#define TT_SV_EO00K                   30
#define TT_US_EO00K                   40

/* --- Values for kernel task states */
#define TSK_INITIALIZED_EO00K                 10
#define TSK_INACTIVE_EO00K                    11
#define TSK_MARKED_FOR_STARTUP_EO00K          12
#define TSK_RUNNING_EO00K                     13
#define TSK_CONNECTWAIT_EO00K                 14
#define TSK_VDEVSIZE_EO00K                    15
#define TSK_VATTACH_EO00K                     16
#define TSK_V2INFO_EO00K                      17
#define TSK_VBLOCKIO_EO00K                    18
#define TSK_V2BLOCKIO_EO00K                   19
#define TSK_VDETACH_EO00K                     20
#define TSK_VFOPEN_EO00K                      21
#define TSK_VFREAD_EO00K                      22
#define TSK_VFWRITE_EO00K                     23
#define TSK_VFCLOSE_EO00K                     24
#define TSK_VRELEASE_EO00K                    25
#define TSK_VSHUTDOWN_EO00K                   26
#define TSK_VRECEIVE_EO00K                    27
#define TSK_VREPLY_EO00K                      28
#define TSK_VNRESTART_EO00K                   29
#define TSK_VNSHUTDOWN_EO00K                  30
#define TSK_VNOPEN_EO00K                      31
#define TSK_VNREQUEST_EO00K                   32
#define TSK_VNRECEIVE_EO00K                   33
#define TSK_VNCLOSE_EO00K                     34
#define TSK_VBEGEXCL_EO00K                    35
#define TSK_VENDEXCL_EO00K                    36
#define TSK_VSUSPEND_EO00K                    37
#define TSK_VWAIT_EO00K                       38
#define TSK_VSLEEP_EO00K                      39
#define TSK_VDIAGINIT_EO00K                   40
#define TSK_VOPMSG_EO00K                      41
#define TSK_LOCKED_EO00K                      42
#define TSK_TERMINATED_EO00K                  43
#define TSK_RUNNABLE_EO00K                    44
#define TSK_ASYNOPEN_EO00K                    45
#define TSK_ASYNCLOSE_EO00K                   46
#define TSK_ASYNIO_EO00K                      47
#define TSK_ASYNWAIT_READ_EO00K               48
#define TSK_ASYNWAIT_WRITE_EO00K              49
#define TSK_VCREATE_EO00K                     50
#define TSK_VKILL_EO00K                       51
#define TSK_IO_READ_EO00K                     52
#define TSK_IO_WRITE_EO00K                    53
#define TSK_IO2_READ_EO00K                    54
#define TSK_IO2_WRITE_EO00K                   55
#define TSK_VACKNOWLEDGE_EO00K                56
#define TSK_VNCLEAR_EO00K                     57
#define TSK_ASYNCNTL_EO00K                    58
#define TSK_DCOM_OBJ_CALLED_EO00K             59     
#define TSK_RESCHEDULE_MSEC_EO00K             60     
#define TSK_INSERT_EVENT_EO00K                61     
#define TSK_WAIT_FOR_EVENT_EO00K              62     
#define TSK_LAST_EO00K                        63     

#define MX_SUSPEND_REASONS_EO00K            256
#define MX_DEVQUEUELEN_STAT_EO00K             3


/*----------------------------------------------------------------------------*
 *  MACROS                                                                    *
 *----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                    *
 *----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*
 *  FUNCTION PROTOTYPES                                                       *
 *----------------------------------------------------------------------------*/



#endif  /* GEO00K_H */
