/* @lastChanged: "1998-02-27 10:15"

  * @filename:   heo54k.h
  * @purpose:    "vblockio"
  * @release:    7.1.0.0
  * @see:        "-.-"
  *
  * @copyright:  "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifndef HEO54K_H
#define HEO54K_H

#include "gsp00.h"
#include "vsp002.h"

#define         DEVSPACE_PAGE_SHFT        ((KGS)->ulDBPageShift) /* 2<<DEVSPACE_PAGE_SHFT == PAGE_SIZE */

/* --- Disk IO ---------------------------------------------------------------- */

typedef unsigned char           V2_RETURN;
typedef unsigned char           V2_DEVNO;

typedef V2_RETURN               tsp_v2_return;
typedef V2_DEVNO                tsp_v2_devno;

#define DEV_READ                0
#define DEV_WRITE               1

#define V2_OK                   0
#define V2_NOTOK                1
#define V2_NOSUPPORT            2

#define V2_DEV1                 0
#define V2_DEV2                 1
#define V2_DEV1_2               2


/* --- VOS54KC ---------------------------------------------------------------- */

externC void           vdevsize          ( tsp00_Int4                  type_spec_devno,
                                           tsp2_dev_type_Param         devtype,
                                           tsp00_Int4    VAR_VALUE_REF devcapacity,
                                           tsp00_ErrText VAR_ARRAY_REF errtext,
                                           tsp00_Bool    VAR_VALUE_REF pOk );

externC void           v2info            ( tsp00_Int4                  devno1,
                                           tsp00_Int4                  devno2,
                                           tsp00_ErrText VAR_ARRAY_REF errtext,
                                           V2_RETURN     VAR_VALUE_REF rtc );

externC void           vattach           ( tsp00_Int4                  type_spec_devno,
                                           tsp2_dev_type_Param         devtype,
                                           tsp00_Int4    VAR_VALUE_REF devno,
                                           tsp00_TaskId                taskId,
                                           tsp00_ErrText VAR_ARRAY_REF errtext,
                                           tsp00_Bool    VAR_VALUE_REF pOk );

externC void           vdetach           ( tsp00_Int4                  devno,
                                           tsp00_TaskId                taskId );

externC void           v2blckio          ( tsp00_Int4                  devno1,
                                           tsp00_Int4                  devno2,
                                           tsp_page_no                 devpno,
                                           tsp2_io_op_code_Param       op_code,
                                           tsp00_PageAddr              bufadr,
                                           tsp00_Int2                  buf_count,
                                           tsp00_TaskId                taskId,
                                           V2_DEVNO      VAR_VALUE_REF read_dev,
                                           V2_DEVNO      VAR_VALUE_REF error_dev,
                                           tsp00_ErrText VAR_ARRAY_REF errtext1,
                                           tsp00_ErrText VAR_ARRAY_REF errtext2,
                                           tsp00_Bool    VAR_VALUE_REF ok );

externC void           vblockio          ( tsp00_Int4                  devno,
                                           tsp00_PageNo                devpno,
                                           tsp2_io_op_code_Param       op_code,
                                           tsp00_PageAddr              pageAddr,
                                           tsp00_Int2                  pageCount,
                                           tsp00_TaskId                taskId,
                                           tsp00_ErrText VAR_ARRAY_REF errtext,
                                           tsp00_Bool    VAR_VALUE_REF pOk );


externC void           vmark_bad_dev     ( tsp00_Int4                  devno,
                                           tsp00_PageNo                devpno ) ;

externC tsp00_Int4     vget_data_io_cnt  ( void ) ;
externC void           vdump_rte         ( void );



#endif
