/* @lastChanged: "1998-02-27 10:15"

  * @filename:   heo56k.h
  * @purpose:    "scheduling"
  * @release:    7.1.0.0
  * @see:        "-.-"
  *
  * @copyright:  "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifndef HEO56K_H
#define HEO56K_H

#include "gsp00.h"

/* --- VOS56KC / VEN56C ------------------------------------------------------- */


externC void                   vsuspend         ( tsp00_TaskId      pid,
												  tsp00_Uint1       suspend_level,
												  tsp00_Int2        suspend_reason );

externC void                   vresume          ( tsp00_TaskId      pid,
												  tsp00_Uint1       suspend_level);

externC void                   vwait            ( tsp00_TaskId      pid,
												  tsp00_Bool       *ok );

externC void                   vsignal          ( tsp00_TaskId      pid,
												  tsp00_Bool        ok );

externC void                   vsleep           ( tsp00_TaskId      pid,
												  tsp00_Int2        limit );


externC void                   vreschedule_msec ( tsp00_TaskId      pid,
                                                  tsp00_Int4       *StartMsec,
                                                  tsp00_Int4       *RemainMsec );

#endif
