/*!***************************************************************************

  module      : heo58.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: vcold / v*dev* 
  description : devspace description ( after xparamfiles has been read )

  last changed: 2001-01-02  12:12
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/

#ifndef HEO58_H
#define HEO58_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "gsp200.h"
#include "vsp002.h"
#include "geo002.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC tsp00_Bool  sql58k_check_dup_devspace_name( DEVSPACES_DESCR *DevspacesDesc,
                                                    tsp2_devnamec    szDevspaceName );

externC DEV_DESCR * sql58k_get_devsp_descr ( tsp2_dev_type       dev_type,
                                             tsp00_Int4          type_spec_devno );

externC void        vcold             ( struct tsp200_xparam_rec VAR_VALUE_REF prms,
                                        tsp200_vcold_result      VAR_VALUE_REF vcold_result);

externC void	      vget_devsize      ( tsp2_dev_type            dev_type ,
                                        tsp00_Int4               type_spec_devno ,
                                        tsp00_Int4 VAR_VALUE_REF dev_size ,
                                        tsp00_Bool VAR_VALUE_REF ok ) ;

externC void	      vget_devname      ( tsp2_dev_type            dev_type ,
                                        tsp00_Int4               type_spec_devno ,
                                        tsp2_devname             dev_name ,
                                        tsp00_Bool VAR_VALUE_REF ok ) ;

externC void	      vnew_devspace     ( tsp2_dev_type            dev_type ,
                                        tsp00_Int4               type_spec_devno ,
                                        tsp2_devname             dev_name ,
                                        tsp00_Int4               dev_size ,
                                        tsp00_Bool VAR_VALUE_REF ok ) ;

externC void	      vget_uniqe_id     ( tsp00_Line VAR_ARRAY_REF uniqe_id );

externC void	      vrevoke_devspace  ( tsp2_dev_type        dev_type ,
                                        tsp00_Int4           type_spec_devno );

externC void	      vinit_akdump_ptr  ( void  *acv_pointer ,      /* CR 1000209 */
                                        void (*ak_dump_proc)() ); /* CR 1000209 */

externC void	      *vGetAcvPtrFromCurrentTask() ;                /* CR 1104345 */


externC void        vdiaginit         ( tsp00_Bool      VAR_VALUE_REF traceflag,
												                tsp00_Bool      VAR_VALUE_REF dumpflag,
												                tsp00_VFilename VAR_ARRAY_REF vtracename,
												                tsp00_Int4      VAR_VALUE_REF vtracesize,
 					                              tsp00_VFilename VAR_ARRAY_REF vdumpname
            					                  );

/* PTS 1108768 */
/*!
  Function:    vInitTraceAndDump
  Description: Initialization Function to retrieve Trace and Dump Information

  This function also formats the knltrace devspace, thereby reserving space
  on disk for it.

  Arguments: vtraceName [out] Name of Tracefile (knltrace)
             vdumpName  [out] Name of Dumpfile (knldump)
 */
externC void        vInitTraceAndDump ( tsp00_VFilename VAR_ARRAY_REF vtraceName,
                                        tsp00_VFilename VAR_ARRAY_REF vdumpName
            					                );
/*!
  Function: vIsDumpWanted
  Description: Request current status of dump wanted flag
  Return value: true if dump of kernel structures is wanted, false if not
 */
externC tsp00_Bool  vIsDumpWanted  ( );

/*!
  Function: vIsTraceWanted
  Description: Request current status of trace wanted flag
  Return value: true if writing kernel trace is wanted, false if not
 */
externC tsp00_Bool  vIsTraceWanted ( );

#endif  /* HEO58_H */
