/****************************************************************************

  module      : hkb04.h

  -------------------------------------------------------------------------

  responsible : JuergenA

  special area: KB_object_handling_interface
  description : 


  last changed: 1999-06-22  15:48
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin  GPL
    Copyright (C) 2000 SAP AG

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
    ========== licence end

*****************************************************************************/


#ifndef HKB04_H
#define HKB04_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "ggg92.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externCpp void
kb04CreateObjFile (tgg00_TransContext &Trans,
                   tgg00_FileId       &ObjFile,
                   tsp00_Int4          ObjBodyLen,
                   tsp00_Int4          ObjKeyLen);

/*---------------------------------------------------------------------------*/

externCpp void
kb04CreateObjIndex (tgg00_TransContext &Trans,
                    tgg00_FileId       &ObjFile,
                    tgg00_ObjColDesc   &InvColDesc);


/*---------------------------------------------------------------------------*/

externCpp void
kb04DeleteAllObj (tgg00_TransContext &Trans,
				  tgg00_FileId		 &ObjFile,
				  tsp00_Int4       &NumDelObj);

/*---------------------------------------------------------------------------*/

externCpp void
kb04DeleteObj (tgg00_TransContext &Trans,
               tgg00_FileId       &ObjFile,
               tgg92_KernelOid     Oid,
               tgg91_PageRef       WantedObjVers,
               tgg00_ObjColDesc   &ColDesc);

/*---------------------------------------------------------------------------*/

externCpp void
kb04EndConsistentTrans (tgg00_TransContext &Trans);


/*---------------------------------------------------------------------------*/

externCpp void
kb04GetObjConsistent (tgg00_TransContext &Trans,
                      tgg00_FileId	     &ObjFile,	   
                      tgg92_KernelOid     Oid,
                      tsp00_Int4	      ObjBodySize,    //[inp=buffer size for object] 
                      void			     *pObjBody,       //[inp]
          			  bool                bDoLock,        //[inp] 
                      tsp00_Int4         &ObjBodyLen,     //[out=real object length]
                      tgg91_PageRef      &ResultObjVers);

/*---------------------------------------------------------------------------*/

externCpp void
kb04GetObjWithKeyConsistent (tgg00_TransContext	 &Trans,
                             tgg00_FileId	     &ObjFile,
                             tsp00_Int4		      ObjBodySize,
                             void			     *pObjBody,
                             tsp00_Int4	          KeyLen,
                             void		         *pKey,
                             bool                 bDoLock,      //[inp] 
                             tgg92_KernelOid     &ResultOid,
                             tgg91_PageRef       &ResultObjVers);

/*---------------------------------------------------------------------------*/

/* PTS 1106284 UH 07-04-2000 new */
externCpp void
kb04IsObjHistoryUsed (tgg00_TransContext &Trans,
                      tgg00_FileId       &ObjFile,
                      tgg92_KernelOid     Oid,
                      bool               &bHistoryIsUsed);

/*---------------------------------------------------------------------------*/

/* PTS 1001745 UH 23-11-1998 new */
externCpp void
kb04IsObjSelfLocked (tgg00_TransContext &Trans,
                     tgg00_FileId       &ObjFile,
                     tgg92_KernelOid     Oid,
                     bool               &IsSelfLocked);

/*---------------------------------------------------------------------------*/

externCpp void
kb04LockObj (tgg00_TransContext &Trans,
             tgg00_FileId       &ObjFile,    
             tgg92_KernelOid     Oid,
             tgg91_PageRef       WantedObjVers);

/*---------------------------------------------------------------------------*/


externCpp void
kb04NewObj (tgg00_TransContext &Trans,
            tgg00_FileId       &ObjFile,
            tsp00_Int4          KeyLen,
            void               *KeyColumn,
            tgg92_KernelOid    &ResultOid,
            tgg91_PageRef      &ResultObjVers);

/*---------------------------------------------------------------------------*/

externCpp void
kb04NextObjConsistent (tgg00_TransContext &Trans,
                       tgg00_FileId       &ObjFile,    
                       tgg92_KernelOid    &CurrOid,
                       bool                bWithObject,
                       tsp00_Int4          ObjBodySize,
                       void               *pObjBody,
                       tgg91_PageRef      &ResultObjVers);

/*---------------------------------------------------------------------------*/

externCpp void
kb04StartConsistentTrans (tgg00_TransContext &Trans);


/*---------------------------------------------------------------------------*/

externCpp void
kb04UnlockObj (tgg00_TransContext &Trans,
               tgg00_FileId       &ObjFile, 
               tgg92_KernelOid     Oid);

/*---------------------------------------------------------------------------*/


externCpp void
kb04UpdateObj (tgg00_TransContext &Trans,
               tgg00_FileId       &ObjFile,
               tgg92_KernelOid     Oid,
               tgg91_PageRef      &ObjVers,
               tsp00_Int4          NewBodySize,
               void               *pNewBody,
               tgg00_ObjColDesc   &ColDesc);


/*---------------------------------------------------------------------------*/

#endif /* HKB04_H */