/*! 
  -----------------------------------------------------------------------------
 
  module: hls27_dataextract.h
 
  -----------------------------------------------------------------------------
 
  responsible:  SteffenS

  special area: Replication Manager
 
  description:  Functions for dataextract
                
  version:      7.3.

  -----------------------------------------------------------------------------
 
  copyright:    SAP AG, 1999-2001
 
  -----------------------------------------------------------------------------


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifndef HLS27_DATAEXTRACT
#define HLS27_DATAEXTRACT

#include "gls00.h"

#define CURSOR_FOR_SEL_LS27				  _T("DECLARE %s CURSOR FOR SELECT %s")
#define CURSOR_FOR_SEL_STAR_LS27          _T("DECLARE %s CURSOR FOR SELECT * from %s")
#define CURSOR_FOR_SEL_STAR_ORDER_LS27    _T("DECLARE %s CURSOR FOR SELECT * from %s ORDER BY %s")

/*!
  -----------------------------------------------------------------------------
 
  function:     ls27ExecDataExtract

  -----------------------------------------------------------------------------

  description:  Dataextract main function

  arguments:    DextCmd      [IN]  - extract command structure
                DBInfo       [IN]  - structure with all info on the running
                                      session and the database connected to
                pszErrText   [OUT] - error text

  returnvalue:  errOK_els00           everything went fine
                errors
  -----------------------------------------------------------------------------
*/
int
ls27ExecDataExtract(tls00_DatExtrCmd *DextCmd, tls00_DBInfo *DBInfo, tsp00_Addr ErrText);

#endif //HLS27_DATAEXTRACT