/* @lastChanged: "1998-04-28  15:51"
 * @filename:    gos35k.h
 * @purpose:     "DCOMx_Functions"
 * @release:     7.1.0.0
 * @see:         ""
 *
 * @copyright:   "Copyright by   SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */


#ifndef GOS35K_H
#define GOS35K_H

/*----------------------------------------------------------------------------*
 *  INCLUDES                                                                  *
 *----------------------------------------------------------------------------*/

#include "geo52.h"

/*----------------------------------------------------------------------------*
 *  DEFINES                                                                   *
 *----------------------------------------------------------------------------*/

#define TASK_REL_OS35K	    0
#define UKT_REL_OS35K	    1


/*----------------------------------------------------------------------------*
 *  MACROS                                                                    *
 *----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                    *
 *----------------------------------------------------------------------------*/

//
// +---------------------------------------------------------------+
// |   DCOM0 THREAD CONTROL                                        |
// +---------------------------------------------------------------+
//

typedef struct tos35k_DCOM0Ctrl 
{
  tos00k_ThreadCtrlHeader           ThrdCtrlHdr_os35k;   // - !!! must be the first entry - see above !!!

  // ---  The DCOM-queue is a fixed list pointing in ring
  tos00k_DCOMQueue                  *pWorkQue_os35k;
  tos00k_DCOMQueue                  *pReqQue_os35k;
  tos00k_DCOMQueue                  *pDCOMs_os35k;       // - DCOM-queue elements
  ULONG                             QueLen_os35k;

  LONG                              Exclusive_os35k;     // - used to grant exclusive exccess
} tos35k_DCOM0Ctrl;

//
// +---------------------------------------------------------------+
// |   DCOMi  THREAD CONTROL                                       |
// +---------------------------------------------------------------+
//
typedef struct tos35k_DCOMiCtrl 
{
  tos00k_ThreadCtrlHeader           ThrdCtrlHdr_os35k;      // - !!! must be the first entry - see above !!!
  ULONG                             Relationship_os35k;     // - TASK_REL_OS35K or UKT_REL_OS35K

  // ---  The dcom-queue is a fixed list pointing in ring
  tos00k_DCOMQueue                  *pWorkQue_os35k;
  tos00k_DCOMQueue                  *pReqQue_os35k;
  tos00k_DCOMQueue                  *pDCOMs_os35k;          // - dcom-queue elements
  ULONG                             NumOfDCOMs_os35k;
  ULONG                             QueLen_os35k;
  ULONG                             MaxQueLen_os35k;

  LONG                              Exclusive_os35k;        // - used to grant exclusive exccess
  teo52_ActionTime                  DCOMStat_os35k;
} tos35k_DCOMiCtrl;


/*----------------------------------------------------------------------------*
 *  FUNCTION PROTOTYPES                                                       *
 *----------------------------------------------------------------------------*/

externC void os35k_VDCOMTransfer         ( void            *pTransferBuffer,
                                           bool            *pOk,
                                           tsp00_ErrText   *pErrtext );

externC bool os35k_RemoveDCOMi           ( void );

externC void os35k_DCOM0                 ( void );

#endif  /* GOS35K_H */
