/****************************************************************************

  module      : gos541.h

  -------------------------------------------------------------------------

  responsible : FrankH

  special area: Intel PSE 36 support 
  description : ramdisk


  last changed: 1999-05-28  10:19
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GOS541_H
#define GOS541_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

ULONG  os541IsPSE36        ( char     *FileName) ;

char  *os541PSE36GetDeviceName (char *DeviceName, 
                                int  MaxNameLen ) ;

DWORD  os541PSE36GetSize   ( char     *PSE36DriveName,
                             LONGLONG *SizeAvailable );

DWORD  os541PSE36Open      ( char     *PSE36DriveName, 
                             HANDLE   *hRamDisk );

DWORD  os541PSE36Close     ( HANDLE   hRamDisk  ) ;

DWORD  os541PSE36Read      ( HANDLE   hRamDisk,
                             PVOID    Buffer,
                             ULONG    Length,
                             LONGLONG Offset,
                             ULONG    *read ) ;

DWORD os541PSE36Write      ( HANDLE   hRamDisk,
                             PVOID    Buffer,
                             ULONG    Length,
                             LONGLONG Offset,
                             ULONG    *written );

LONG sql541PSE36Seek       ( HANDLE   hRamDisk,
                             LONGLONG Offset,
                             DWORD    Method) ;

LONG sql541PSE36Read       ( HANDLE   hRamDisk,
                             PVOID    Buffer,
                             ULONG    Length,
                             ULONG   *BytesRead ) ;

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/

#endif  /* GOS541_H */
