/****************************************************************************

  module      : gos543.h

  -------------------------------------------------------------------------

  responsible : FrankH

  special area: Intel extended memory support 
  description : "Windows 2000 PAE/AWE-Support"


  last changed: 1999-08-19  9:39
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GOS543_H
#define GOS543_H


/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gos00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/


/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC int os543AWE_AllocatPhysicalPages ( ULONG  *NumberOfPhysPagesWanted_Available,
                                            void  **AWE_SpaceForPhysPagesFrameNumbers ) ;

externC int os543AWE_FreePhysicalPages    ( ULONG  *NumberOfPhysPagesWanted_Available,
                                            void  **AWE_SpaceForPhysPagesFrameNumbers );

externC int os543AWE_AllocatMappingRegion ( void **MappingAddress,
                                            int    MappingSizeInBytes ) ;

externC int os543AWE_FreeMappingRegion    ( void **MappingAddress ) ;

externC int os543AWE_Map                  ( void  *MappingAddress,
                                            int    NumberOfPhysPages,
                                 		    void  *AWEPhysPagesFrameStart,
                            			    int    AWEOffset) ;

externC int os543AWE_UnMap                ( void  *MappingAddress,
                                            int    NumberOfPhysPages ) ;

externC int os543AWE_LoadFunctions        () ;

externC int os543AWE_GetDllVersion        ( tsp100_VersionID1 *pVersion );

/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/

#endif  /* GOS543_H */
