/* @lastChanged: "1998-02-24 10:15"

  * @filename:   hos65k.h
  * @purpose:    "vasynio"
  * @release:    7.1.0.0
  * @see:        "-.-"
  *
  * @copyright:  "Copyright by SAP AG, 1998"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/

#ifndef HOS65K_H
#define HOS65K_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "gsp00.h"
#include "gos00.h"

/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

// --- ASYNC_IO ------- VA_RETURN ---------------------------------------------

#define VA_OK                   0
#define VA_NOTOK                1
#define VA_EOF                  2
#define VA_WAIT_FIRST           3

// --- VOS65KC ----------------------------------------------------------------

VOID                   vasynopen         ( tsp00_VFilename hostfile,
                                           BOOLEAN         is_devspace,
                                           BOOLEAN         for_writing,
                                           tsp_vf_type     filetype,
                                           tsp_int4        block_size,
                                           tsp_int4        * max_blockcount,
                                           tsp_int4        * hostfileno,
                                           tsp00_VaReturn  * error,
                                           tsp00_ErrText   errtext );

VOID                   vasynclose        ( tsp_int4        hostfileno,
                                           BOOLEAN         rewind,
                                           BOOLEAN         nxt_in_autoloader,
                                           tsp00_VaReturn  * nxt_tape_available,
                                           tsp00_VaReturn  * error,
                                           tsp00_ErrText   errtext );

VOID                   vasynio           ( tsp_int4        hostfileno,
                                           tsp_int4        io_id,
                                           tsp_int4        file_pos,
                                           tsp_int4        io_block_cnt,
                                           BUFFERADDRESS   io_block_ptr,
                                           tsp00_VaReturn  * error,
                                           tsp00_ErrText   errtext );

VOID                   vasynwait         ( tsp_int4        hostfileno,
                                           tsp_int4        * io_id,
                                           tsp_int4        * io_block_cnt,
                                           tsp00_VaReturn  * error,
                                           tsp00_ErrText   errtext );

VOID                   vasyninit_tape    ( tsp_int4        deviceno,
                                           BOOLEAN         destructive, 
                                           tsp_vf_type     * filetype,
                                           tsp00_VaReturn  * error,
                                           tsp00_ErrText   errtext );
#endif
