/*!**********************************************************************

  module: hwd128help.h

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus Oezgen

  special area: WebAgent

  description:  Help messages for command-line-tools

  see also:

  -----------------------------------------------------------------------

  copyright:              copyright by SAP AG, 1999


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

#ifndef HWD128HELP_H
#define HWD128HELP_H

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include "gwd00.h"

#if defined(__cplusplus)
extern "C" {
#endif

sapdbwa_Bool wd128HelpOption( sapdbwa_Int4 argc, char *argv[] );
    
void wd128ShowHelp( const char *helpStr,
                    const char *usageStr,
                    const char *optionsStr );

void wd128ShowUsage( const char *usageStr, const char *optionsStr );
    
#define DBFORMAT_HELP_WD128 "dbformat: Create new database filesystem.\n\
Caution: An existing filesystem is erased with all its contents."
#define DBMKDIR_HELP_WD128 "dbmkdir: Create a new directory in the database \
filesystem."
#define DBRMDIR_HELP_WD128 "dbrmdir: Delete directory in the dbfs. \
The directory to delete must be empty."
#define DBCPIN_HELP_WD128 "dbcpin: Copy a file from the local filesystem \
into the database filesystem."
#define DBCPOUT_HELP_WD128 "dbcpout: Copy a file from the database filesystem \
into the local filesystem."
#define DBLS_HELP_WD128 "dbls: Show the contents of a directory in the \
database filesystem."
#define DBRM_HELP_WD128 "dbrm: Remove file in the database filesystem."
#define DBMV_HELP_WD128 "dbmv: Move files or directory trees in the database filesystem."
#define DBCP_HELP_WD128 "dbmv: Copy files or directory trees in the database filesystem."
#define DBLN_HELP_WD128 "dbln: Create a link to a file or directory in the database filesytsem."
    
#define DBFORMAT_USAGE_WD128 "dbformat [<options>]"
#define DBMKDIR_USAGE_WD128 "dbmkdir [<options>] <new dbfs path>"
#define DBRMDIR_USAGE_WD128 "dbrmdir [<options>] <dbfs path>"
#define DBCPIN_USAGE_WD128 "dbcpin [<options>] <local file> <dbfs path>"
#define DBCPOUT_USAGE_WD128 "dbcpout [<options>] <dbfs file> <local path>"
#define DBLS_USAGE_WD128 "dbls [<options>] [<dbfs path>]"
#define DBRM_USAGE_WD128 "dbrm [<options>] <dbfs file>"
#define DBMV_USAGE_WD128 "dbmv [<options>] <dbfs file or dir> <new dbfs file or dir>"
#define DBCP_USAGE_WD128 "dbcp [<options>] <dbfs file or dir> <new dbfs file or dir>"
#define DBLN_USAGE_WD128 "dbln [<options>] <dbfs file or dir> <new link (full path)>"

#define HELP_ONLY_OPTIONS_WD128 "  -?\t Display help message."
    
#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif
