/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
#ifndef HWD202MSG_H
#define HWD202MSG_H
/*!**********************************************************************

  module: hwd201sock.h

  -----------------------------------------------------------------------

  responsible:  

  special area: WebAgent

  description:  Messages for socket interface

  see also:

  -----------------------------------------------------------------------

                         Copyright by SAP AG, 1999

************************************************************************/

#define ERR_11001_WD202   "WSAHOST_NOT_FOUND: Host not found"
#define ERR_11002_WD202   "WSATRY_AGAIN: Non-Authoritative Host not found"
#define ERR_11003_WD202   "WSANO_RECOVERY: Non-Recoverable errors: FORMERR, REFUSED, NOTIMP"
#define ERR_11004_WD202   "WSANO_DATA: Valid name, no data record of requested type"

#define ERR_10091_WD202   "WSASYSNOTREADY: Network SubSystem is unavailable"
#define ERR_10092_WD202   "WSAVERNOTSUPPORTED: WINSOCK DLL Version out of range"
#define ERR_10093_WD202   "WSANOTINITIALISED: Successful WSASTARTUP not yet performed"

#define ERR_10064_WD202   "WSAEHOSTDOWN: Host is down"
#define ERR_10065_WD202   "WSAEHOSTUNREACH: No Route to Host"
#define ERR_10066_WD202   "WSAENOTEMPTY: Directory not empty"
#define ERR_10067_WD202   "WSAEPROCLIM: Too many processes"
#define ERR_10068_WD202   "WSAEUSERS: Too many users"
#define ERR_10069_WD202   "WSAEDQUOT: Disc Quota Exceeded"
#define ERR_10070_WD202   "WSAESTALE: Stale NFS file handle"
#define ERR_10071_WD202   "WSAEREMOTE: Too many levels of remote in path"

#define ERR_10048_WD202   "WSAEADDRINUSE: Address already in use"
#define ERR_10049_WD202   "WSAEADDRNOTAVAIL: Can't assign requested address"
#define ERR_10050_WD202   "WSAENETDOWN: Network is down"
#define ERR_10051_WD202   "WSAENETUNREACH: Network is unreachable"
#define ERR_10052_WD202   "WSAENETRESET: Net dropped connection or reset"
#define ERR_10053_WD202   "WSAECONNABORTED: Software caused connection abort"
#define ERR_10054_WD202   "WSAECONNRESET: Connection reset by peer"
#define ERR_10055_WD202   "WSAENOBUFS: No buffer space available"
#define ERR_10056_WD202   "WSAEISCONN: Socket is already connected"
#define ERR_10057_WD202   "WSAENOTCONN: Socket is not connected"
#define ERR_10058_WD202   "WSAESHUTDOWN: Can't send after socket shutdown"
#define ERR_10059_WD202   "WSAETOOMANYREFS: Too many references, can't splice"
#define ERR_10060_WD202   "WSAETIMEDOUT: Connection timed out"
#define ERR_10061_WD202   "WSAECONNREFUSED: Connection refused"
#define ERR_10062_WD202   "WSAELOOP: Too many levels of symbolic links"
#define ERR_10063_WD202   "WSAENAMETOOLONG: File name too long"

#define ERR_10035_WD202   "WSAEWOULDBLOCK: Operation would block"
#define ERR_10036_WD202   "WSAEINPROGRESS: Operation now in progress"
#define ERR_10037_WD202   "WSAEALREADY: Operation already in progress"
#define ERR_10038_WD202   "WSAENOTSOCK: Socket operation on non-socket"
#define ERR_10039_WD202   "WSAEDESTADDRREQ: Destination address required"
#define ERR_10040_WD202   "WSAEMSGSIZE: Message too long"
#define ERR_10041_WD202   "WSAEPROTOTYPE: Protocol wrong type for socket"
#define ERR_10042_WD202   "WSAENOPROTOOPT: Bad protocol option"
#define ERR_10043_WD202   "WSAEPROTONOSUPPORT: Protocol not supported"
#define ERR_10044_WD202   "WSAESOCKTNOSUPPORT: Socket type not supported"
#define ERR_10045_WD202   "WSAEOPNOTSUPP: Operation not supported on socket"
#define ERR_10046_WD202   "WSAEPFNNOSUPPORT: Protocol family not supported"
#define ERR_10047_WD202   "WSAEAFNNOSUPPORT: Address family not supported by protocol family"

#define ERR_10022_WD202   "WSAEINVAL: Invalid argument"
#define ERR_10024_WD202   "WSAEMFILE: Too many open files"

#define ERR_10000_WD202   "[0] No Error"
#define ERR_10004_WD202   "WSAEINTR: Interrupted system call"
#define ERR_10009_WD202   "WSAEBADF: Bad file number"
#define ERR_10013_WD202   "WSACCESS: Permission denied"
#define ERR_10014_WD202   "WSAEFAULT: Bad address"

#define ERR_UNKNOWN_WD202 "Unknown socket error"

#endif
