/*!**********************************************************************

  module: hwd203util.h

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus zgen

  special area: WebAgent

  description:  Utility functions (UNIX compatibility etc.)

  see also:

  -----------------------------------------------------------------------

                         Copyright by SAP AG, 1999


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

#ifndef HWD203UTIL_H
#define HWD203UTIL_H

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include <stdarg.h>

#include "hwd201sock.h"

#define	LOG_EMERG	0	
#define	LOG_ALERT	1	
#define	LOG_CRIT	2	
#define	LOG_ERR		3	
#define	LOG_WARNING	4	
#define	LOG_NOTICE	5	
#define	LOG_INFO	6	
#define	LOG_DEBUG	7	

#if defined(__cplusplus)
extern "C" {
#endif

    /* n: LOG_... (see above) */
    void syslog ( int n, const char *fmt, ...);

    void vsyslog( int n, const char *fmt, va_list ap );

    void wd203makeIPAddr( twd201_SockAddrIn  sockName,
                          char              *buf,
                          sapdbwa_Int4         bufLen );

    void wd203SockErr( const char *where, const char *sockFunc );

    void wd203Error( const char *where,
                     const char *sockFunc,
                     const char *errMsg );
    
    sapdbwa_Bool wd203Accept( twd201_Socket      lstnSocket,
                      twd201_Socket     *pIncomingSock,
                      twd201_SockAddrIn *pIncomingSockName);

    void wd203Sleep( sapdbwa_UInt4 msec );
    
#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif
