/*!**********************************************************************

  module: vwd128help.h

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus Oezgen

  special area: WebAgent

  description:  Help messages for command-line-tools

  see also:

  -----------------------------------------------------------------------

  copyright:              copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include <stdio.h>
#include <string.h>

#include "hwd128help.h"


void wd128_ShowOptions( const char *optionsStr );

sapdbwa_Bool wd128HelpOption( sapdbwa_Int4 argc, char *argv[] )
{
    return (argc >=2 &&
            ((strcmp( argv[1], "-h" ) == 0)
             || (strcmp( argv[1], "-help" ) == 0)
             || (strcmp( argv[1], "-?" ) == 0)
             || (strcmp( argv[1], "/help" ) == 0)
             || (strcmp( argv[1], "/?" ) == 0)
             || (strcmp( argv[1], "/h" ) == 0)
             || (strcmp( argv[1], "--helph" ) == 0)));
} /* wd128HelpOption */


void wd128ShowHelp( const char *helpStr,
                    const char *usageStr,
                    const char *optionsStr )
{
    printf( "%s\n\n", helpStr );
    printf( "Usage: %s\n\n", usageStr );
    wd128_ShowOptions( optionsStr );
} /* wd128ShowHelp */


void wd128ShowUsage( const char *usageStr, const char *optionsStr )
{
    printf( "Usage: %s\n\n", usageStr );
    wd128_ShowOptions( optionsStr );
} /* wd128ShowUsage */


void wd128_ShowOptions( const char *optionsStr )
{
    printf( "<options>:\n%s\n", optionsStr );
} /* wd128_ShowOptions */
