/*!**********************************************************************

  module: vwd127mv.c

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus Oezgen

  special area: WebAgent

  description:  DB-Filesystem dbcp executable

  see also:

  -----------------------------------------------------------------------

  copyright:               Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include <stdio.h>

#include "hwd101dbfs.h"
#include "hwd128help.h"

int main( int argc, char *argv[] )
{
    if (wd128HelpOption( argc, argv )) {
        wd128ShowHelp( DBCP_HELP_WD128,
                       DBCP_USAGE_WD128,
                       HELP_ONLY_OPTIONS_WD128 );
    } else if (argc != 3) {
        wd128ShowUsage( DBCP_USAGE_WD128, HELP_ONLY_OPTIONS_WD128 );
    } else {
        if (!wd101InitDBFS()) {
            printf(" init failed.");
            printf( "%s \n", wd101CmdGetErrorMsg() );
            return 1;
        }; /* if */

        if (!wd101CmdCopy( argv[1], argv[2] )) {
            printf( "%s \n", wd101CmdGetErrorMsg() );
        }; /* if */
    
        wd101ExitDBFS();
    }; /* else */
    
    return 0;
} /* main */
