/*!**********************************************************************

  module: hwd208err.h

  -----------------------------------------------------------------------

  responsible:  Holger Bischoff
				Markus zgen

  special area: WebAgent

  description:  C++ Error Object derived from twd26ErrP

  see also:

  -----------------------------------------------------------------------

  copyright:                 Copyright by SAP AG, 1999



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

************************************************************************/

/*=======================================================================
 *  INCLUDES
 *=====================================================================*/

#include "hwd208err.h"

/*!**********************************************************************

  Chapter: twd208_Err

************************************************************************/

// default constructor
twd208_Err::twd208_Err()
{
    this->err = wd26CreateErr();
}; // twd208_Err


// create from twd26ErrP
twd208_Err::twd208_Err( twd26ErrP errP )
{
    this->err = wd26CreateErr();
    if (this->err != NULL) {
        wd26CopyErr( this->err, errP );
    }; // if
}; // twd208_Err


// copy constructor
twd208_Err::twd208_Err( const twd208_Err &errObj )
{
    if (this->err != NULL) {
        wd26CopyErr( this->err, errObj.err );
    }; // if
}; // twd208_Err


// destructor
twd208_Err::~twd208_Err()
{
    if (this->err != NULL) {
        wd26DestroyErr( this->err );
    }; // if
}; // ~twd208_Err


twd208_Err& twd208_Err::operator =( const twd208_Err &errObj )
{
    if (this->err != NULL) {
        wd26CopyErr( this->err, errObj.err );
    }; // if
    return *this;
}; // operator =    

/*!**********************************************************************

  EndChapter: twd208_Err

************************************************************************/
